<?php

//---------------------------------------------------------------------------
// authentication
//
// This is the authentication service that executes as with all php on the 
// server hosting the Web application via a web server such as Apache or 
// your Glass Fish test server.
// 
// A service is invokes from the browser of client via a http request. There
// are two types used and are called "Get" and "Post" methods.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// get - session
// 
// The session data is stored in the client and with the get request is
// passed to this service that is then used to verify the user's current
// session.
//---------------------------------------------------------------------------
$app->get('/session', function() {
    $db = new DbHandler();
    $session = $db->getSession();
    $response["UID"] = $session['UID'];
    $response["Email"] = $session['Email'];
    $response["UserName"] = $session['UserName'];
    $response["Level"] = $session['Level'];
    $response["Company"] = $session['Company'];
    $response["CID"] = "$2a$10$2013f4dcaf44c0c0a5f89eGm55.ocFXdljBUoS7dBjqCI3r58DyHi";
    echoResponse(200, $response);
});

//---------------------------------------------------------------------------
// post - login
//
// The post request has a data set the accompanies the service request. The 
// data is passed as a string jason representation that is then decoded as 
// a reference to a class containing the parameters sent from the client
// (browser). This will verify the login require data and return a status.
//---------------------------------------------------------------------------
$app->post('/login', function() use ($app) {
    require_once 'passwordHash.php';
    $r = json_decode($app->request->getBody());
    verifyRequiredParams(array('Email', 'Password'), $r->customer);
    $response = array();
    $db = new DbHandler();
    $Password = $r->customer->Password;
    $Email = $r->customer->Email;
    $user = $db->getOneRecord("select UID,UserName,Password,Email,Level,created,Company from users where Email='$Email'");
    if ($user == NULL) {
        $user = $db->getOneRecord("select UID,UserName,Password,Email,Level,created,Company from users where UserName='$Email'");
    }
    if ($user != NULL) {
        if (passwordHash::check_password($user['Password'], $Password)) {
            $response['status'] = "success";
            $response['message'] = 'Logged in successfully.';
            $response['UserName'] = $user['UserName'];
            $response['UID'] = $user['UID'];
            $response['Email'] = $user['Email'];
            $response['Level'] = $user['Level'];
            $response['createdAt'] = $user['created'];
            // Update the user session data.
            if (!isset($_SESSION)) {
                session_start();
            }
            $_SESSION['UID'] = $user['UID'];
            $_SESSION['Email'] = $user['Email'];
            $_SESSION['UserName'] = $user['UserName'];
            $_SESSION['Level'] = $user['Level'];
            $_SESSION['Company'] = $user['Company'];
        } else {
            $response['status'] = "error";
            $response['message'] = 'Login failed. Incorrect credentials';
        }
    } else {
        $response['status'] = "error";
        $response['message'] = 'No user with name or phone is registered';
    }
    echoResponse(200, $response);
});

//---------------------------------------------------------------------------
// post - signUp
//
// This allows a user to signin that creates a user account with very limited
// access previlidges with respect to see LSS data and of coarse operations.
// As noted this is good for creating an account that will later require
// an administrator to change access rights.
//---------------------------------------------------------------------------
$app->post('/signUp', function() use ($app) {
    require_once 'passwordHash.php';
    $db = new DbHandler();
    // Process the the request.
    $response = array();
    $r = json_decode($app->request->getBody());
    verifyRequiredParams(array('Email', 'UserName', 'Password'), $r->customer);
    require_once 'passwordHash.php';
    $db = new DbHandler();
    $UserName = $r->customer->UserName;
    $Email = $r->customer->Email;
    // The administrator will need to provide access.
    $r->customer->Level= USER_USER;
    $isUserExists = $db->getOneRecord("select 1 from users where UserName='$UserName'");
    $isEmailExists = $db->getOneRecord("select 1 from users where Email='$Email'");
    if (!$isUserExists && !$isEmailExists) {
        $r->customer->Password = passwordHash::hash($Password);
        $table_name = "users";
        $column_names = array('Phone', 'UserName', 'Email', 'Password', 'Level', 'NotificationType');
        $result = $db->insertIntoTable($r->customer, $column_names, $table_name);
        if ($result != NULL) {
            $response["status"] = "success";
            $response["message"] = "User account created successfully";
            $response["UID"] = $result;
            if (!isset($_SESSION)) {
                session_start();
            }
            echoResponse(200, $response);
        } else {
            $response["status"] = "error";
            $response["message"] = "Failed to create user. Please try again.";
            echoResponse(201, $response);
        }
    } else {
        $response["status"] = "error";
        $response["message"] = "A user with the provided name or email already exists!";
        echoResponse(201, $response);
    }
});

//---------------------------------------------------------------------------
// post - addUser
//
// This is used by a manager or administrator to add a user. A user is not 
// allowed to add a user.
//---------------------------------------------------------------------------
$app->post('/addUser', function() use ($app) {
    require_once 'passwordHash.php';
    $db = new DbHandler();
    // The current user must be a manager or administrator.
    if (!isset($_SESSION)) {
        session_start();
    }
    $level = intval($_SESSION['Level']);
    if($level !== USER_ADMIN && $level !== USER_MANAGER){
        $response = array();
        $response['status'] = "error";
        $response['message'] = "Access Denied, Insufficient user priviledges, see administrator";
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
        exit();        
    }
    // If an administrator is logged in, continue.        
    $response = array();
    $r = json_decode($app->request->getBody());        
    verifyRequiredParams(array('Email', 'UserName', 'Password'), $r->customer);
    $UserName = $r->customer->UserName;
    $Email = $r->customer->Email;
    $Password = $r->customer->Password;
    // The administrator will need to provide access, a Manager can't add
    // an administrator, a manager can add a manager.
    $reqLevel = intval($r->customer->Level);
    if($reqLevel > $level){
       $r->customer->Level = USER_USER;
    }
    $isUserExists = $db->getOneRecord("select 1 from users where UserName='$UserName'");
    $isEmailExists = $db->getOneRecord("select 1 from users where Email='$Email'");
    if (!$isUserExists && !$isEmailExists) {
        $r->customer->Password = passwordHash::hash($Password);
        $column_names = array('Phone', 'UserName', 'Email', 'Company', 'Password', 'Level', 'NotificationType');
        $result = $db->insertIntoTable($r->customer, $column_names, 'users');
        if ($result != NULL) {
            $response["status"] = "success";
            switch (intval($r->customer->Level))
            {
                case USER_MANAGER:
                    $response["message"] = "Manager account created successfully";
                    break;
                case USER_ADMIN:
                    $response["message"] = "Administrator account created successfully";
                    break;
                default:
                    $response["message"] = "User account created successfully";
                    break;
            }
            $response["UID"] = $result;
            echoResponse(200, $response);
        } else {
            $response["status"] = "error";
            $response["message"] = "Failed to create user. Please try again.";
            echoResponse(201, $response);
        }
    } else {
        $response["status"] = "error";
        $response["message"] = "A user with the provided name or email already exists!";
        echoResponse(201, $response);
    }
});

//---------------------------------------------------------------------------
// post - managerSignUp
//
// This requires an administrator to be logged in, and only an administrator 
// can add other managers or can include other users. 
//---------------------------------------------------------------------------
$app->post('/managerSignUp', function() use ($app) {
    require_once 'passwordHash.php';
    $db = new DbHandler();
    // The current user must be an administrator. The SESSION var got nuked
    if (!isset($_SESSION)) {
        session_start();
    }
    $level = intval($_SESSION['Level']);
    if($level !== USER_ADMIN){
        $response = array();
        $response['status'] = "error";
        $response['message'] = "Access Denied, Insufficient user priviledges, see administrator";
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
        exit();        
    }
    // If an administrator is logged in, continue.        
    $response = array();
    $r = json_decode($app->request->getBody());        
    verifyRequiredParams(array('Email', 'UserName', 'Password'), $r->customer);
    $UserName = $r->customer->UserName;
    $Email = $r->customer->Email;
    $Password = $r->customer->Password;
    $r->customer->Level = USER_MANAGER;
    $isUserExists = $db->getOneRecord("select 1 from users where UserName='$UserName'");
    $isEmailExists = $db->getOneRecord("select 1 from users where Email='$Email'");
    if (!$isUserExists && !$isEmailExists) {
        $r->customer->Password = passwordHash::hash($Password);
        $table_name = "users";
        $column_names = array('Phone', 'UserName', 'Email', 'Company', 'Password', 'Level', 'NotificationType');
        $result = $db->insertIntoTable($r->customer, $column_names, $table_name);
        if ($result != NULL) {
            $response["status"] = "success";
            $response["message"] = "Company manager account created successfully";
            $response["UID"] = $result;
            echoResponse(200, $response);
        } else {
            $response["status"] = "error";
            $response["message"] = "Failed to create user. Please try again.";
            echoResponse(201, $response);
        }
    } else {
        $response["status"] = "error";
        $response["message"] = "A user with the provided name or email already exists!";
        echoResponse(201, $response);
    }
});


//---------------------------------------------------------------------------
// get logout
//
// Basically executes a nice shutdown and cleans up the session data. The 
// client will and should update the cockie(s) as required, past navagation 
// history is lost.
//---------------------------------------------------------------------------
$app->get('/logout', function() {
    $db = new DbHandler();
    $session = $db->destroySession();
    $response["status"] = "info";
    $response["message"] = "Logged out successfully";
    echoResponse(200, $response);
});

//---------------------------------------------------------------------------
// post - modifyuser
//
// Finds the current table entry by Email and then updates the row.
//---------------------------------------------------------------------------
$app->post('/modifyUser', function() use ($app) {
    $response = array();
    $r = json_decode($app->request->getBody());
    verifyRequiredParams(array('Email', 'UserName', 'Password'), $r->customer);
    require_once 'passwordHash.php';
    $db = new DbHandler();
    $Phone = $r->customer->Phone;
    $UserName = $r->customer->UserName;
    $Email = $r->customer->Email;
    $Password = $r->customer->Password;
    $isUserExists = $db->getOneRecord("select 1 from users where Email='$Email' and UserName='$UserName'");
    if ($isUserExists) {
        $r->customer->Password = passwordHash::hash($Password);
        $table_name = "users";
        $column_names = array('Phone', 'UserName', 'Email', 'Company', 'Password', 'Level', 'NotificationType');
        $result = $db->updateExistingRecord($r->customer, $column_names, $table_name);
        if ($result != NULL) {
            $response["status"] = "success";
            $response["message"] = "User account successfully modified.";
           echoResponse(200, $response);
        } else {
            $response["status"] = "error";
            $response["message"] = "Failed to modify user. Please try again";
            echoResponse(201, $response);
        }
    } else {
        $response["status"] = "error";
        $response["message"] = "The specified User does not exist!";
        echoResponse(201, $response);
    }
});
?>