/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// dbDeleteTestController
// 
// This a test of the delete data base service, this is only a test if this 
// was an actual controller then you will be told where to tune in to. This 
// is only a test.....
//---------------------------------------------------------------------------
app.controller('dbDeleteTestController', function ($scope, dbDeleteService) {

    $scope.testDbDeleteCmd = function (table) {
        var dataItem = null;
        
        // For this test we are using the common structures that include 
        // column 0 and is not used with the sql insert command.
        switch(table)
        {
            case EnumDbDeleteCmds.USER:
                dataItem = new UsersStruct();
                dataItem.Name = 'test';
                dataItem.Company = 'USL';
                dataItem.Email = 'test';
                dataItem.Phone = '8051234567';
                break;
            case EnumDbDeleteCmds.GROUP:
                dataItem = new GroupsStruct();
                dataItem.PID = 96;
                dataItem.GroupName = 'Central Coast';
                dataItem.OrgKey = 'uslinc.com';
                break;                                
            case EnumDbDeleteCmds.THEATERGROUP:
                dataItem = new TheaterGroupsStruct();
                dataItem.Theater = 'USL Theaters';
                dataItem.OrgKey = 'uslinc.com';
                dataItem.GroupId = 4;
                break;
            case EnumDbDeleteCmds.USERGROUP:
                dataItem = new UserGroupsStruct();
                dataItem.UserId = 9;
                dataItem.GroupId = 10;
                break;
        }
        
        if(dataItem !== null)
            dbDeleteService.dbDelete(table, dataItem);
    };

});


