/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
app.controller('navbarCtrl', function ($rootScope,$scope,$location,getParametersFactory) {
    $scope.parameters = getParametersFactory;
    $scope.affixed = 'top';
    $scope.search = {
        show: true,
        terms: ''
    };
    // Insert company image localization here
    $scope.brand = '<span class=\'glyphicon glyphicon-user\'></span> LSS Database';
    $scope.inverse = true;
    $scope.loginstate = true; // For testing
    // Build the menu system wby tracking the Level of the current user.
    // Database action is also protected, this just make s a friendlier view
    $rootScope.$watch('Level', function(newName){
    if ($scope.loginstate === true) {
        $scope.menus = [
            {title: 'Logout', action: 'logAction', glyphicon:'log-out',highlight:false},
            {title: 'Theaters', action: 'theaterAction', glyphicon:'film',highlight:false},
            {title: 'Screens', action: 'screenAction', glyphicon:'facetime-video',highlight:false},
            {title: 'Notifications', action: 'notifyAction', glyphicon:'send',highlight:false},
            {title: 'Configure', glyphicon:'cog',highlight:false,
                menu: [
                        {title: 'Display Settings', action: 'displaySettings'},
                        {title: 'Modify User', action: 'modifyUser'}
                ]}
        ];
            //Give correct menu options based on user's level
            if($rootScope.Level===1){  //  Company Admin
                $scope.menus[4].menu.push({divider: true});
                $scope.menus[4].menu.push({title: 'Add User', action: 'addUser'});
                $scope.menus[4].menu.push({title: "Modify Groups", action:'modifyGroups'});
    }
            if($rootScope.Level===2){  //  Super User
                $scope.menus[4].menu.push({divider: true});
                $scope.menus[4].menu.push({title: 'Add User', action: 'addUser'});
                $scope.menus[4].menu.push({title: "Modify Groups", action:'modifyGroups'});
                $scope.menus[4].menu.push({title: 'New Company', action: 'newCompany'});
                $scope.menus[4].menu.push({divider: true});
                $scope.menus[4].menu.push({title: 'Mail Admin', action: 'mailAdmin'});
                $scope.menus[4].menu.push({title: 'Notifications Admin', action: 'notificationsAdmin'});
                $scope.menus[4].menu.push({title: 'Database Admin', action: 'dbAdmin'});
            }
        }
    else {
        $scope.menus = [
            {   title: 'Log In', action: 'logAction', controller: 'authCtrl',highlight:false},
            {   title: 'Sign up', action: 'signUp',highlight:false}];
    }
    });
    $scope.item = '';
    $scope.styling = 'Inverse';
    $scope.searchDisplay = 'Visible';
    $scope.searchfn = function () {
        alert('Attempting search on: "' + $scope.search.terms + '"');
    };
    // Clicking the navbar functionality
    $scope.path = '';
    $scope.navfn = function (action) {
        // For highlighting the menu option
        for( menu in $scope.menus ){
            $scope.menus[menu].highlight=false;
            if( 'menu' in $scope.menus[menu] ){
                for( i in $scope.menus[menu].menu ){
                    if($scope.menus[menu].menu[i].action === action){
                        $scope.menus[menu].highlight=true;
                    }
                }
            }
            if($scope.menus[menu].action===action){
                $scope.menus[menu].highlight=true;
            }
        }
        // Reroute the view
        console.log('lssnavbar: Action ='+action);
        console.log('lssnavbar: Autenticated = '+$rootScope.authenticated);
        switch (action) {
            case 'logAction':
                if($rootScope.authenticated)
                    $scope.path = ("/logout");
                else
                    $scope.path = ("/login");
                
                break;
            case 'logOut':
                $scope.path = ("/logout");
                break;
            case 'signUp':
                $scope.path = ('/signup');
                break;
            case 'theaterAction':
                $scope.path = ('/theaters');
                break;
            case 'screenAction':
                $scope.path = ('/screens');
                break;
            case 'notifyAction':
                $scope.path = ('/notifications');
                break;
            case 'addUser':
                $scope.path = ('/adduser');
                break;
            case 'modifyUser':
                $scope.path = ('/modifyuser');
                break;
            case 'modifyGroups':
                $scope.path = ('/modifygroups');
                break;
            case 'newCompany':
                $scope.path = ('/newcompany');
                break;
            case 'adminReports':
                $scope.path = ('/adminreports');
                break;
            case 'lssConfiguration':
                $scope.path = ('/lssconfiguration');
                break;
            case 'displaySettings':
                $scope.path = ('/displaysettings');
                break;
            case 'dbAdmin':
                $scope.path = ('/dbadmin');
                break;
            case 'mailAdmin':
                $scope.path = ('/mailadmin');
                break;
            case 'notificationsAdmin':    
                $scope.path = ('/notificationsadmin');
                break;
            default:
                $scope.path = ('/dashboard');
                break;
        };    
        $scope.parameters.loc = $scope.path;
        $location.path($scope.path);
    };
    $scope.toggleStyling = function () {
        $scope.inverse = !$scope.inverse;
        if (angular.equals($scope.inverse, true))
            $scope.styling = 'Inverse';
        else
            $scope.styling = 'Default';
    };
    $scope.toggleSearchForm = function () {
        $scope.search.show = !$scope.search.show;
        if (angular.equals($scope.search.show, true))
            $scope.searchDisplay = 'Visible';
        else
            $scope.searchDisplay = 'Hidden';
    };
    $scope.addMenu = function () {
        $scope.menus.push({
            title: 'Added On The Fly!',
            action: 'default'
        });
    };
    $scope.toggleAffixed = function () {
        switch ($scope.affixed) {
            case 'top':
                $scope.affixed = 'bottom';
                break;
            case 'bottom':
                $scope.affixed = 'none';
                break;
            case 'none':
                $scope.affixed = 'top';
                break;
        }
        ;
    };
})

.directive('angledNavbar', function () {
    return {
        restrict: 'AE',
        scope: {
            brand: '=',
            menus: '=',
            affixed: '=',
            search: '=',
            searchfn: '&',
            navfn: '&',
            inverse: '='
        },
        templateUrl: 'tmpls/nav/navbar.html',
        controller: function ($scope, $element, $attrs, createDialog) {
            $scope.defaults = {
                brand: '<span class="glyphicon glyphicon-certificate"></span>',
                menus: [],
                search: { show: false }
            };
            if (angular.isUndefined($attrs.navfn)) {
                $scope.navfn = function (action) {
                    if (angular.isObject(action))
                        $scope.$emit('nav.menu', action);
                    else
                        $scope.$emit('nav.menu', { 'action': action });
                };
            }
            if (angular.isUndefined($attrs.searchfn)) {
                $scope.searchfn = function () {
                    $scope.$emit('nav.search.execute');
                };
            }
            $scope.$watch('affixed', function (val, old) {
                var b = angular.element(document).find('body');
                if (angular.equals(val, 'top') && !b.hasClass('navbar-affixed-top')) {
                    if (b.hasClass('navbar-affixed-bottom'))
                        b.removeClass('navbar-affixed-bottom');
                    b.addClass('navbar-affixed-top');
                } else if (angular.equals(val, 'bottom') && !b.hasClass('navbar-affixed-bottom')) {
                    if (b.hasClass('navbar-affixed-top'))
                        b.removeClass('navbar-affixed-top');
                    b.addClass('navbar-affixed-bottom');
                } else {
                    if (b.hasClass('navbar-affixed-top'))
                        b.removeClass('navbar-affixed-top');
                    if (b.hasClass('navbar-affixed-bottom'))
                        b.removeClass('navbar-affixed-bottom');
                }
            });
            $scope.about = function () {                
                createDialog('../partials/about.html',{
                    id: 'simpleDialog',
                    title: 'LSS Database',                    
                    footerTemplate:'<button class="btn btn-primary" ng-click="$modalCancel()">{{$modalCancelLabel}}</button>',
                    backdrop: true,
                    modalClass: "modal",
                    cancel: {label: 'Close', fn: null},
                });
            };
            $scope.navAction = function (action) {
                $scope.navfn({ 'action': action });
            };
            $scope.haveBranding = function () {
                return angular.isDefined($attrs.brand) ? $scope.brand : $scope.defaults.brand;
            };
            $scope.hasMenus = function () {
                return angular.isDefined($attrs.menus);
            };
            $scope.hasDropdownMenu = function (menu) {
                return angular.isDefined(menu.menu) && angular.isArray(menu.menu);
            };
            $scope.isDivider = function (item) {
                return angular.isDefined(item.divider) && angular.equals(item.divider, true);
            };
        }
    };
})
 //  Build the HTML for the navbar
.run(function ($templateCache) {
    $templateCache.put('tmpls/nav/navbar.html', 
        '<nav class="navbar" ng-class="{\'navbar-inverse\': inverse,\'navbar-default\': '+
        '!inverse,\'navbar-fixed-top\': affixed == \'top\',\'navbar-fixed-bottom\': '+
        'affixed == \'bottom\'}" role="navigation"><div class="container-fluid">'+
        '<div class="navbar-header"><button type="button" class="navbar-toggle" '+
        'data-toggle="collapse" data-target="#navbar-menu"><span class="sr-only">Toggle Navigation</span>'+
        '<span class="icon-bar"></span><span class="icon-bar"></span><span class="icon-bar"></span>'+
        '</button><a class="navbar-brand" ng-click="about()" ng-bind-html="haveBranding()">'+
        '</a></div><div class="collapse navbar-collapse" id="navbar-menu">'+
        '<ul class="nav navbar-nav" ng-if="hasMenus()">'+
        '<li ng-repeat="menu in menus" ng-class="{true: \'dropdown\'}[hasDropdownMenu(menu)]">'+
        '<a ng-if="!hasDropdownMenu(menu)" ng-click="navAction(menu.action)" ng-class="{highlighted:menu.highlight}">'+
        '<span class="glyphicon glyphicon-{{menu.glyphicon}}" aria-hidden="true" /> {{menu.title}}</a>'+
        '<a ng-if="hasDropdownMenu(menu)" class="dropdown-toggle" data-toggle="dropdown" ng-class="{highlighted:menu.highlight}">'+
        '<span class="glyphicon glyphicon-{{menu.glyphicon}}" aria-hidden="true" /> {{menu.title}} <b class="caret"></b>'+
        '</a><ul ng-if="hasDropdownMenu(menu)" class="dropdown-menu">'+
        '<li ng-repeat="item in menu.menu" ng-class="{true: \'divider\'}[isDivider(item)]">'+
        '<a ng-if="!isDivider(item)" ng-click="navAction(item.action)">{{item.title}}</a>'+
        '</li></ul></li></ul><form ng-if="search.show" class="navbar-form navbar-right" role="search"><div class="form-group">'+
        '<input type="text" class="form-control" placeholder="Search" ng-model="search.terms"><button class="btn btn-default" '+
        'type="button" ng-click="searchfn()"><span class="glyphicon glyphicon-search"></span></button></div></form></div></div></nav>');
});
