/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// mailAdminController
//
// This will interface with the Mail Administration page to configure 
// the mail server settings.
//---------------------------------------------------------------------------
app.controller('mailAdminController', function ($rootScope, $scope, mailService) {
    $scope.settingsDisabled = true;
    // Note that the constructor has default values
    $scope.Settings = new EmailSettingsStruct();
    
    //-----------------------------------------------------------------------
    //                   Web Service Request
    //                   
    // Retrieve the current settings from the database.                  
    //-----------------------------------------------------------------------
    mailService.getSettings($scope.Settings);
        
    // Dropdown list items.
    $scope.serverTypes = [
        {
            text: 'SMTP',
            value: EnumMailServerTypes.SMTP
        }, {
            text: 'PHP Mail',
            value: EnumMailServerTypes.PHPMAIL
        }, {
            text: 'Send Mail',
            value: EnumMailServerTypes.SENDMAIL           
        }, {
            text: 'Qmail',
            value: EnumMailServerTypes.QMAIL 
        }, {
            text: 'No Mail',
            value: EnumMailServerTypes.NONE 
        }
    ];
    
    //-----------------------------------------------------------------------
    // $watch Settings
    //
    // When a server response is received this will enable the settings
    // buttons. 
    //-----------------------------------------------------------------------
    $scope.$watch('Settings', function(newValue){
        if(newValue instanceof EmailSettingsStruct)
        {
            if(newValue.Valid === true)
            {
                $scope.settingsDisabled = false;
            }
        }
    },true);    
    
    $scope.sendTestMail = function () {
        // The constructor by default creates a test mail
        var mailItem = new EmailMessageStruct();
        mailItem.To = $rootScope.Email;
        mailItem.ToName = $rootScope.UserName;
        // Send the email item.
        mailService.send(mailItem);
    };
    
    $scope.getMailSettings = function () {
        mailService.getSettings($scope.Settings);
    };

    $scope.saveMailSettings = function () {
        mailService.setSettings($scope.Settings);
    };
           
});



