/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
app.controller('notificationController', function ($scope, $timeout, $location,
        getParametersFactory, configurationFactory,  dbRequestService) {
    // Declarations
    $scope.settings = configurationFactory;
    $scope.parameters = getParametersFactory;
    $scope.totalItems =0;
    $scope.notificationlist = [];
    $scope.notificationrecords = [];
    $scope.opened = [false,false];  // For datepicker display control
    //
    // Controller Functions
    // Populate the notifications list
    dbRequestService.dbRequest($scope.notificationlist, EnumDbCmds.NOTIFICATIONS, $scope.parameters.startdate.getTime()/1000, $scope.parameters.enddate.getTime()/1000);
    // Watch the database for changes
    $scope.$watchCollection('notificationlist', function(newNames, oldNames){
        console.log('Found '+newNames.length+' notifications for user');
        $scope.totalItems = newNames.length;
    });
     $scope.$watchCollection('notificationrecords', function(newNames, oldNames){
        console.log('Selected date had '+newNames.length);
        $scope.totalItems = newNames.length;
        for(var i in newNames){
            newNames[i]['id']=$scope.ids[i];
        }
    });
    $scope.lastIndex = "";
    $scope.ids = [];
    $scope.HeaderClick = function($index,$dt){
        $scope.ids.length=0;
        $(".panel-body").hide();
        if($index !== $scope.lastIndex){
            $scope.notificationrecords.length=0;
        for (i in $scope.notificationlist) {
                 if($scope.notificationlist[i].SentDate === $dt){ $scope.ids.push($scope.notificationlist[i].RawDataId);}
        }
        dbRequestService.dbRawDataRequest( $scope.notificationrecords, EnumDbCmds.RawDataRequest, $scope.ids );
        $("#note"+$index).toggle();
            $scope.lastIndex = $index;
        }
        else{ $scope.lastIndex = ""; }
    };
    $scope.recCount = function($dt) {
        var count = 0;
        angular.forEach($scope.notificationlist, function(nli){
            count += nli.SentDate===$dt ? 1 : 0;
        });
        return count;
    }
    // Re capture the data when the date range is changed
    $scope.dateRangeChange = function(){
        dbRequestService.dbRequest($scope.notificationlist, EnumDbCmds.NOTIFICATIONS, $scope.parameters.startdate.getTime()/1000, $scope.parameters.enddate.getTime()/1000);
    };
    // Redirect to the screen view
    $scope.screenClick = function($rec){
        $scope.parameters['theater'] = $rec.TheaterNumber;
        $scope.parameters['screen'] = $rec.AuditoriumNumber;
        $scope.parameters['orgkey'] = $rec.OrgKey;
        $scope.parameters['id'] = $rec.id;
        $scope.parameters['description'] = $rec.Description;
        $scope.parameters['startdate'] = new Date(parseFloat($rec.DateTime)*1000 - (7*24*60*60*1000));
        $scope.parameters['enddate'] = new Date(parseFloat($rec.DateTime)*1000 + (24*60*60*1000));
        $location.path('/screens');
    };
    //Date Selection
    $scope.open = function($event, $index) {
      $event.preventDefault();
      $event.stopPropagation();

      $scope.opened[$index] = true;
    };
});