<?php 
//---------------------------------------------------------------------------
// Common include file for the php database server side code.
//
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//                          User Type Access Definitions
//---------------------------------------------------------------------------
define('USER_USER',     0);
define('USER_MANAGER',  1);
define('USER_ADMIN',    2);


//---------------------------------------------------------------------------
//                             Database Definitions
//---------------------------------------------------------------------------
    $DB_HOST = '127.0.0.1';
    $DB_USER = 'lssdb';
    $DB_PASS = 'lssdb';
    $DB_NAME = 'lssdb';
    
//---------------------------------------------------------------------------
//                      Databse Action Command Defintions
//                      
// From the client javascript these commands are defined as enumberations
// that are then passed to the php service as a json converted string. It is
// then coverted to an associated array. 
// 
// !! Import to match the enumerated definitions in lib/appEnum.js                                       
//---------------------------------------------------------------------------
    $DB_CMD_ALL = '0';
    $DB_CMD_OVERVIEW = '1';
    $DB_CMD_THEATER = '2';
    $DB_USER_DATA_ALL = '3';
    $DB_CMD_GROUPS = '4';
    $DB_CMD_THEATERGROUPS = '5';
    $DB_CMD_USERGROUPS = '6';
    $DB_CMD_THEATER_OVERVIEW = '7';
    $DB_CMD_GRAPH_DATA = '8';
    $DB_COLLECT_THEATER_GROUPS= '9';
    $DB_CMD_LSS_DATA = '10';
    $DB_COLLECT_ORGKEYS = '11';
    $DB_CMD_NOTIFICATIONS = '12';
    $DB_CMD_RAWDATA = '13';
    $DB_CMD_MY_GROUPS = '14';
    $DB_CMD_MY_THEATERGROUPS = '15';
    
//---------------------------------------------------------------------------
//                           Database Update Commands
//                           
// Define command types to be used in conjuction with a respective 
// data set to update the respective database table.
//---------------------------------------------------------------------------
    $DB_CMD_UPDATE_USER = 0;
    $DB_CMD_UPDATE_GROUPS = 1;
    $DB_CMD_UPDATE_THEATERGROUPS = 2;
    $DB_CMD_UPDATE_USERGROUPS = 3;
     
//---------------------------------------------------------------------------
//                           Database Add Commands
//  
// Define command types to be used in conjuction with a respective 
// data set to insert the respective database table.
//---------------------------------------------------------------------------
    $DB_CMD_ADD_GROUPS = 0;
    $DB_CMD_ADD_THEATERGROUPS = 1;
    $DB_CMD_ADD_USERGROUPS = 2;

//---------------------------------------------------------------------------
//                           Database Delete Commands
//  
// Define command types to be used in conjuction with a respective 
// data set to delete from respective database table. 
//---------------------------------------------------------------------------
    $DB_CMD_DELETE_USER = 0;
    $DB_CMD_DELETE_GROUP= 1;
    $DB_CMD_DELETE_THEATERGROUP= 2;
    $DB_CMD_DELETE_USERGROUP= 3;
    $DB_CMD_PURGE_USERGROUP_BY_UID = 4;
    $DB_CMD_PURGE_THEATERGROUP = 5;
    $DB_CMD_DELETE_SIMULATIONS = 6;
  
//---------------------------------------------------------------------------
//         Mail Server Setting and Notification Admin commands
//                         
// These definitions must match the enumerated value in the client appEnum.                        
//---------------------------------------------------------------------------
    $DB_CMD_GET_SETTINGS = 0;
    $DB_CMD_SET_SETTINGS = 1;
   
//---------------------------------------------------------------------------
//                           Notification Commands
//
//---------------------------------------------------------------------------
    $DB_CMD_ALL_NOTIFICATIONS = 0;
    $DB_CMD_USER_NOTIFICATIONS = 1;
    $DB_CMD_GROUP_NOTIFICATIONS = 3;
 
//---------------------------------------------------------------------------
//                           Notification Types
//---------------------------------------------------------------------------
    $DB_NOTIFICATIONS_NONE = 0;
    $DB_NOTIFICATIONS_ERRORS = 1;
    $DB_NOTIFICATIONS_ALL = 2;

//---------------------------------------------------------------------------
//                           Notification Status
//                           
// The notifications table contains a column called SentDateTime. When an 
// Email is sent, a timestamp is assigned. By default an Email that has not
// been sent has a value of 0 assigned. When there's an attempt to send an
// Email and it bounces then the value is -1. When a post is received and 
// there are no users assigned, a -2 is used.                         
//---------------------------------------------------------------------------
    $DB_NOTIFICATION_NOT_SENT = 0;
    $DB_NOTIFICATION_FAILED = -1;
    $DB_NOTIFICATION_NOT_ASSIGNED = -2;
   
//---------------------------------------------------------------------------
//                    Database Administration Commands
// 
// Service request commands that are defined in application enumberations.
//---------------------------------------------------------------------------
    $DB_CMD_RAWDATA_STATISTICS = 0;
    $DB_CMD_NOTIFICATION_STATISTICS = 1;
    $DB_CMD_NOTIFICATIONS_PENDING_COUNT = 2;
    $DB_CMD_NOTIFICATION_ERROR_COUNT = 3;
    $DB_CMD_NOTIFICATION_ERROR_ENTRIES = 4;
    $DB_CMD_NOTIFICATIONS_PENDING_DELETE = 5;
    $DB_CMD_RAWDATA_DELETE = 6;
    $DB_CMD_NOTIFICATIONS_DELETE = 7;
    $DB_CMD_ADMIN_RAWDATA = 8;
    $DB_CMD_ADMIN_NOTIFICATIONS = 9;
    $DB_CMD_COMPANIES = 10;
    
//---------------------------------------------------------------------------
//                            Enumeration-Definition
//---------------------------------------------------------------------------
$NONE = '0';

?>
