<?php

//---------------------------------------------------------------------------
// post
//
// This is the external we service used for the LSS-100 to post measurement
// results to the LSS Web Application's database that will be checked to 
// send notifications and provide the data for user review.
//---------------------------------------------------------------------------
include_once('includes/config.php');
include_once('serverservices/notification.php');

// The action must be a post.
if ($_SERVER['REQUEST_METHOD'] == "POST") {
   
    include_once('serverservices/notifications/classAdmin.php');
    
    // Object method 
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    
    $NotifyAdmin = new classAdmin($mysqli);
    
    // get post data into a string
    $PostData = file_get_contents("php://input");
    $uri = $_SERVER['REQUEST_URI'];
    $combined = $uri . "\r\n" . $PostData;

    // Check the connection status.
    if ($mysqli->connect_errno) {
        SetReturnStatus(false);
    }
    else
    {
        // Create the classNotification, contains methods that
        // access and use database results.
        NewNotificationInstance($mysqli);
        $log = new SimpleXMLElement($PostData);
        if ($log) {
            // Write to the system log
            $logMsg = "LSS Post received from ".$log->Record[0]->OrgKey.
                      " , Theater Number ".$log->Record[0]->TheaterNumber.
                      " Auditorium ".$log->Record[0]->AuditoriumNumber;
            syslog(LOG_INFO, $logMsg);
            
            $queryResult = true;
            foreach ($log->Record as $ThisRecord) {
                $ThisRecord->OrgKey = trim($ThisRecord->OrgKey);
                $ThisRecord->RecordNum = NullToZero($ThisRecord->RecordNum); // get rid of null strings that are stored as ints
                $ThisRecord->DateTime = NullToZero($ThisRecord->DateTime);
                $ThisRecord->Value   =  NullToZero($ThisRecord->Value);
                $ThisRecord->Minimum =  NullToZero($ThisRecord->Minimum);
                $ThisRecord->Maximum =  NullToZero($ThisRecord->Maximum);
                $ThisRecord->OutsideLimits = NullToZero($ThisRecord->OutsideLimits);
                $ThisRecord->TheaterNumber = NullToZero($ThisRecord->TheaterNumber);
                $ThisRecord->AuditoriumNumber = NullToZero($ThisRecord->AuditoriumNumber);
                $ThisRecord->Firmware = NullToZero($ThisRecord->Firmware);
                // var_dump($ThisRecord->OrgKey);
                $sql = "INSERT INTO RawData
                    ( 
                    OrgKey,
                    RecordNum,
                    DateTime,
                    Description,
                    Value,
                    Units,
                    Minimum,
                    Maximum,
                    OutsideLimits,
                    SerialNumber,
                    TheaterName,
                    TheaterNumber,
                    AuditoriumNumber,
                    Comments,
                    Firmware,
                    Hardware,
                    IpAddress)
                    VALUES(
                    \"$ThisRecord->OrgKey\",
                    $ThisRecord->RecordNum,
                    $ThisRecord->DateTime,
                    \"$ThisRecord->Description\",
                    $ThisRecord->Value,
                    \"$ThisRecord->Units\",
                    $ThisRecord->Minimum,
                    $ThisRecord->Maximum,
                    $ThisRecord->OutsideLimits,
                    $ThisRecord->SerialNumber,
                    \"$ThisRecord->TheaterName\",
                    $ThisRecord->TheaterNumber,
                    $ThisRecord->AuditoriumNumber,
                    \"$ThisRecord->Comments\",
                    $ThisRecord->Firmware,
                    \"$ThisRecord->Hardware\",
                    \"$ThisRecord->IpAddress\")";
                // check the returned status to log an error.
                if (!$mysqli->query($sql)) {
                    $queryResult = false;
                }
                else
                {   
                    // Get the current primary key value for notification
                    // enrty reference.
                    $RecordId = $mysqli->insert_id;
                    ProcessForNotification($ThisRecord, $RecordId);
                     
                }
                
            }
            
            // If the cron notification process is off, generate
            // a notification emial now!
            if($NotifyAdmin->Running === 0)
            {   
                // Reported items have been collected, report them. 
                SendNotificationMail();
            }
            
            $mysqli->close();
            SetReturnStatus($queryResult);
        }
    }
    
}

//---------------------------------------------------------------------------
// SetReturnStatus
//
// Set the return status to the http post.
//---------------------------------------------------------------------------
function SetReturnStatus($result) {
    if ($result) {
        header("HTTP/1.1 200 OK");
    } else {
        header("HTTP/1.1 406 Not Acceptable");
    }
}

function sanitize($string) {
    return(mysql_real_escape_string($string)); // sanitize input
}

function NullToZero($string) {
    $result = "0";
    if ($string != "")
        $result = $string;
    return($result);
}

?>

