CREATE DATABASE IF NOT EXISTS lssdb;

USE lssdb;

--
-- Table structure for table `Users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `UserName` varchar(50) NOT NULL,
  `Password` varchar(200) NOT NULL,
  `Company` varchar(50) NOT NULL,
  `Level` int(2) NOT NULL DEFAULT 0,
  `NotificationType` int(2) NOT NULL,
  `Email` varchar(50) NOT NULL,
  `Phone` varchar(100) NOT NULL,
  `Created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `groups` (
  `GID` int(11) NOT NULL AUTO_INCREMENT,
  `PID` int(11) NOT NULL DEFAULT 0,
  `GroupName` varchar(50) NOT NULL,
  `OrgKey` varchar(50) NOT NULL,
  PRIMARY KEY (`GID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `usergroups` (
  `UGID` int(11) NOT NULL AUTO_INCREMENT,
  `UserID` int(11) NOT NULL,
  `GroupID` int(11) NOT NULL,
  `Active` int(3) NOT NULL,
  PRIMARY KEY (`UGID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `theatergroups` (
  `TGID` int(11) NOT NULL AUTO_INCREMENT,
  `TheaterName` varchar(50) NOT NULL,
  `OrgKey` varchar(50) NOT NULL,
  `GroupID` int(11) NOT NULL,
  PRIMARY KEY (`TGID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS mailsettings (
    ServerType int(8) NOT NULL DEFAULT 1,
    SMTPAuth BOOLEAN NOT NULL DEFAULT FALSE,
    SMTPSecure varchar(5) NOT NULL DEFAULT 'tls',
    HostName varchar(50) NOT NULL DEFAULT 'localhost.com',
    Port int(11) NOT NULL DEFAULT 25, 
    Username varchar(50) NOT NULL DEFAULT 'root@localhost.com',
    Password varchar(50) NOT NULL DEFAULT 'password'
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 ;

CREATE TABLE IF NOT EXISTS `notifications_sent` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `datetime` datetime NOT NULL,
  `sentok` int(11) NOT NULL DEFAULT '0',
  `user` text NOT NULL,
  `groupid` int(11) NOT NULL,
  `url` text NOT NULL,
  `mailserverresp` text NOT NULL,
  `notificationbody` text NOT NULL,
  `serialnumber` int(11) NOT NULL DEFAULT '0',
  `lssdatetime` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `notifications_admin` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `statustext` text NOT NULL,
  `running` int(11) NOT NULL DEFAULT '0',
  `nextrunsec` int(11) NOT NULL DEFAULT '3600',
  `errors` int(11) NOT NULL DEFAULT '0',
  `intervalsecs` int(11) NOT NULL DEFAULT '3600',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Insert SysAdmin and Technician records to start the database
--

INSERT INTO `users` (`UID`, `UserName`, `Email`, `Phone`, `Password`,`Company`, `Level`,`NotificationType`, `Created`) VALUES
(1, 'System Administrator', 'admin', '1234567890', '$2a$10$c90a864d61a11ca7dbc7au1NO2QvYc3kLdoFeaapopwY90o/2JhHO','USL Inc.','2','2','2015-02-05 00:00:00'),
(2, 'Technician', 'technician', '0987654321', '$2a$10$807c41f29ae85e3730634eMQMgEiXBkfLRachbsluNadXdo21WFgG','USL Inc.','1','1','2015-02-05 00:00:00');

INSERT INTO `groups` (`GID`, `GroupName`,`OrgKey`) VALUES
(1, 'US', 'uslinc.com'),
(2, 'East Coast', 'uslinc.com'),
(3, 'Central', 'uslinc.com'),
(4, 'West Coast', 'uslinc.com');

INSERT INTO mailsettings VALUES (DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT);

INSERT INTO notifications_admin VALUES (DEFAULT,"default",DEFAULT,DEFAULT,DEFAULT,DEFAULT);
