<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/

    //-----------------------------------------------------------------------
    // updateData
    // 
    // The client will post a database action type (command) to perform. 
    // The actions are defined in lib/appEnum and are used by the controller
    // and service to send it to this service as a http post message.
    // 
    // In the service, then client side javascript, the command and parameters
    // are json encoded that is then coverted into a string and passed in
    // the post request. The command type and parameters are used for 
    // determining the database query action. The actions are insert
    // queries.
    //-----------------------------------------------------------------------
    // Secuity Checks
    require_once 'authenticate.php';
    $UserLevel = intval($_SESSION['Level']);
    // Get the database connection and api with action types (command)
    include_once('../includes/config.php');
    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    
    $result = null;
    
    // We only process a post request !
    if($_SERVER['REQUEST_METHOD'] == "POST"){
        // Retrieve the jason data passed in the post.
        $str_json = file_get_contents('php://input');
        // Convert the jason data to an associative array.
        $dataArray = json_decode($str_json, true);
        
        $query = $NONE;
        $result = null;
        
        // Process the service request type
        switch($dataArray['command'])
        {
            case $DB_CMD_ADD_GROUPS:
                if($UserLevel == USER_ADMIN || $dataArray['OrgKey'] == $_SESSION['Company']){
                    // Check if the item exist.
                    $query="SELECT 1 FROM groups WHERE ".
                           "PID=".$dataArray['PID']." AND ".
                           "GroupName=\"".$dataArray['GroupName']."\" AND ".
                           "OrgKey=\"".$dataArray['OrgKey']."\" LIMIT 1";
                    $result = $mysqli->query($query);
                    if($result->num_rows == 0)
                    {   // Add new group
                        $query="INSERT INTO groups ".
                               "(PID,GroupName,OrgKey)".
                               " VALUES ".
                               "(".$dataArray['PID'].",".
                               "\"".$dataArray['GroupName']."\",".
                               "\"".$dataArray['OrgKey']."\")";
                        $result = $mysqli->query($query);
                        ProcessQueryResult($result);
                    }else{
                        ProcessQueryResult(false);
                    }
                }else{
                    ProcessQueryResult(false);
                }
                break;
            case $DB_CMD_ADD_THEATERGROUPS:
                if($UserLevel == USER_ADMIN || $dataArray['OrgKey'] == $_SESSION['Company']){
                    // Check if the item exist.
                    $query="SELECT 1 FROM theatergroups WHERE ".
                           "TheaterNumber=\"".$dataArray['TheaterNumber']."\" AND ".
                           "OrgKey=\"".$dataArray['OrgKey']."\" AND ".
                           "GroupID=".$dataArray['GroupId']." LIMIT 1";
                    $result = $mysqli->query($query);
                    if($result->num_rows == 0)
                    {
                        $query="INSERT INTO theatergroups ".
                               "(TheaterNumber,OrgKey,GroupID)".
                               " VALUES ".
                               "(\"".$dataArray['TheaterNumber']."\",".
                               "\"".$dataArray['OrgKey']."\",".
                               $dataArray['GroupId'].");";
                        $result = $mysqli->query($query);
                        ProcessQueryResult($result);
                    }else{
                        ProcessQueryResult(false);
                    }   
                }else{
                    ProcessQueryResult(false);
                }
                break;
            case $DB_CMD_ADD_USERGROUPS:
                $query = "SELECT 1 FROM users WHERE ".
                        "Company=\"".$_SESSION['Company']."\" AND ".
                        "UID=".$dataArray['UserId'];
                $result = $mysqli->query($query);
                if($UserLevel === USER_ADMIN || $result->num_rows>0){
                    // Check if the item exist.
                    $query="SELECT 1 FROM usergroups WHERE ".
                           "UserID=".$dataArray['UserId']." AND ".
                           "GroupID=".$dataArray['GroupId']." AND ".
                           "Active=".$dataArray['Active']." LIMIT 1";
                    $result = $mysqli->query($query);
                    if($result->num_rows == 0)
                    {
                        $query="INSERT INTO usergroups ".
                               "(UserID,GroupID,Active)".
                               " VALUES ".
                               "(".$dataArray['UserId'].",".
                               $dataArray['GroupId'].",".
                               $dataArray['Active'].")";
                        $result = $mysqli->query($query);
                        ProcessQueryResult($result);
                        break;
                    }else{
                        ProcessQueryResult(false);
                    }
                }else{
                    ProcessQueryResult(false);
                }
            default:
                ProcessQueryResult(false);
                break;
        }
         
    }
    
    //-----------------------------------------------------------------------
    // ProcessQueryResult
    //
    // This will return the results without further processing. The status 
    // will create a respective toaster message to appear.
    //-----------------------------------------------------------------------
    function ProcessQueryResult($result)
    {
        $response = array();
        if($result === null || $result === false)
        {
            $response['status']  = "error";
            $response['message'] = "Add action failed, already exist.";
        }else{
            $response['status']  = "success";
            $response['message'] = "New item successfully added.";
        }        
        // Encode the response
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
    }


?>
