<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/

    //---------------------------------------------------------------------------
    // deleteData
    // 
    // The item to be removed from the database must exist prior to executing the
    // delect query. Depending on the table, there columns being checked for 
    // where will very.
    // 
    // Review each command case with regards to setting up the request.
    //---------------------------------------------------------------------------
    // Secuity Checks
    require_once 'authenticate.php';
    $UserLevel = intval($_SESSION['Level']);
    // Get the database connection and api with action types (command)
    include_once('../includes/config.php');
    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    
    // We only process a post request !
    if($UserLevel >= USER_MANAGER){
        // Retrieve the jason data passed in the post.
        $str_json = file_get_contents('php://input');
        // Convert the jason data to an associative array.
        $dataArray = json_decode($str_json, true);
        
        $query = $NONE;
        $result = null;
        
        // Process the service request type
        switch($dataArray['command'])
        {
            case $DB_CMD_DELETE_USER:
                // Check if the item exist.
                $query="SELECT 1 FROM users WHERE ";
                if($UserLevel === USER_MANAGER){
                    $query.="Company=\"".$_SESSION["Company"]."\" AND ";
                }
                $query.="UserName=\"".$dataArray['Name']."\" AND ".
                       "Email=\"".$dataArray['Email']."\"";
                $result = $mysqli->query($query);
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM users WHERE ";
                    if($UserLevel === USER_MANAGER){
                        $query.="Company=\"".$_SESSION["Company"]."\" AND ";
                    }
                    $query.="UserName=\"".$dataArray['Name']."\" AND ".
                    "Email=\"".$dataArray['Email']."\" LIMIT 1";
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result);                    
                }else{
                    ProcessQueryResult(false);
                }
                break;            
            case $DB_CMD_DELETE_GROUP:
                // Check if the item exist.
                if($UserLevel >= USER_MANAGER || $_SESSION['Company'] === $dataArray['OrgKey']){
                $query="SELECT 1 FROM groups WHERE ".
                            "GID=".$dataArray['GID']." AND ".
                       "PID=".$dataArray['PID']." AND ".
                       "GroupName=\"".$dataArray['GroupName']."\" AND ".
                       "OrgKey=\"".$dataArray['OrgKey']."\"";
                $result = $mysqli->query($query);
                }
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM groups WHERE ".
                           "GID=".$dataArray['GID']." AND ".
                           "GroupName=\"".$dataArray['GroupName']."\" AND ".
                           "OrgKey=\"".$dataArray['OrgKey']."\" LIMIT 1";
                    $result = $mysqli->query($query);
                    $result2 = null;
                    // Delete the associations to this group
                    $query="DELETE FROM usergroups WHERE ".
                           "GroupID=".$dataArray['GID'];
                    $result2 = $mysqli->query($query);
                    $query="DELETE FROM theatergroups WHERE ".
                           "GroupID=".$dataArray['GID'];
                    $result2 = $mysqli->query($query);
                    $query="SELECT GID FROM groups WHERE ".
                        "PID=".$dataArray['GID'];
                    $result2 = $mysqli->query($query);
                    if($result2->num_rows > 0) {
                        while($row = $result2->fetch_assoc()) {
                            $result3 = null;
                            $query="UPDATE groups SET ".
                                   "PID=\"0\" ".
                                   "WHERE GID=".$row['GID'];
                            $result3 = $mysqli->query($query);
                        }
                    }
                    ProcessQueryResult($result);
                }else{
                    ProcessQueryResult(false);
                }
                break;
            case $DB_CMD_DELETE_THEATERGROUP:
                if($UserLevel >= USER_ADMIN || $_SESSION['Company'] === $dataArray['OrgKey']){
                // Check if the item exist.
                $query="SELECT 1 FROM theatergroups WHERE ".
                       "TheaterNumber=\"".$dataArray['TheaterNumber']."\" AND ".
                       "OrgKey=\"".$dataArray['OrgKey']."\" AND ".
                       "GroupID=".$dataArray['GroupId'];
                $result = $mysqli->query($query);
                }
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM theatergroups WHERE ".
                           "TheaterNumber=\"".$dataArray['TheaterNumber']."\" AND ".
                           "OrgKey=\"".$dataArray['OrgKey']."\" AND ".
                           "GroupID=".$dataArray['GroupId']." LIMIT 1";
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result);
                }else{
                    ProcessQueryResult(false);
                }
                break;
            case $DB_CMD_DELETE_USERGROUP:
                // Check if the item exist.
                $query="SELECT 1 FROM usergroups WHERE ".
                       "UserID=".$dataArray['UserId']." AND ".
                       "GroupID=".$dataArray['GroupId'];
                $result = $mysqli->query($query);
                $result2 = null;
                if($UserLevel < USER_ADMIN ){
                    $query = "SELECT 1 FROM users WHERE ".
                        "UID=".$dataArray['UserId']." AND ".
                        "Company=\"".$_SESSION['Company']."\"";
                    $result2 = $mysqli->query($query);
                    if($result2->num_rows < 1){
                        $result = null;
                    }
                }
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM usergroups WHERE ".
                           "UserID=".$dataArray['UserId']." AND ".
                           "GroupID=".$dataArray['GroupId']." LIMIT 1";
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result);
                }else{
                    ProcessQueryResult(false);
                }
                break;
            case $DB_CMD_PURGE_USERGROUP_BY_UID:
                // Check if the item exist.
                $query="SELECT * FROM usergroups WHERE ".
                       "UserID=".$dataArray['UserId'].";";
                $result = $mysqli->query($query);
                if($result->num_rows > 0 && $UserLevel !== USER_ADMIN){
                    $query="SELECT * FROM users WHERE ".
                           "UID=".$dataArray['UserId']." AND ".
                           "Company=\"".$_SESSION['Company']."\";";
                    $result = $mysqli->query($query);
                }
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM usergroups WHERE ".
                           "UserID=".$dataArray['UserId'].";";
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result);
                }else{
                    // Don't do anything if DB is empty already
                    ProcessQueryResult(true);
                }
                break;
             case $DB_CMD_PURGE_THEATERGROUP:
                // Check if the item exist.
                if($UserLevel === USER_ADMIN || $_SESSION['Company'] === $dataArray['OrgKey']){
                $query="SELECT * FROM theatergroups WHERE ".
                       "TheaterNumber=".'"'.$dataArray['TheaterNumber'].'"'." AND ".
                           "OrgKey=".'"'.$dataArray['OrgKey'].'"'.";";
                $result = $mysqli->query($query);
                }
                if($result->num_rows > 0)
                {
                    $query="DELETE FROM theatergroups WHERE ".
                       "TheaterNumber=".'"'.$dataArray['TheaterNumber'].'"'." AND ".
                           "OrgKey=".'"'.$dataArray['OrgKey'].'"'.";";
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result);
                }else{
                    // Don't do anything if DB is empty already
                    ProcessQueryResult(true);
                }
                break;
            case $DB_CMD_DELETE_SIMULATIONS:
                $query="DELETE FROM RawData WHERE TheaterNumber=-1;";
                $mysqli->query($query);
                $response = array();
                $response['status']  = "info";
                $response['message'] = "Removed older simulated data.";
                $json_response = json_encode($response);
                echo $json_response;
                break;
            default:
                ProcessQueryResult(false);
                break;
        }
        
    }else{
        // Send back a status of access
        $response = array();
        $response['status']  = "info";
        $response['message'] = "Access Denied, Insufficient user priviledges, see manager or administrator";
        // Encode the response
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;        
    }
    
    //-----------------------------------------------------------------------
    // ProcessQueryResult
    //
    // This will return the results without further processing.
    //-----------------------------------------------------------------------
    function ProcessQueryResult($result)
    {
        $response = array();
        if($result === null || $result === false)
        {
            $response['status']  = "error";
            $response['message'] = "Delete action failed, record not found.";
        }else{
            $response['status']  = "success";
            $response['message'] = "Item successfully deleted.";
        }
        // Encode the response
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
    }
    
?>
