<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/

    //-----------------------------------------------------------------------
    // mail
    //
    // Send Mail Web Service
    //
    // This is the mail service based on PhpMailer available from GitHub. The
    // request is a php post that then will load the settings from the data-
    // base and send an email to the configured email server. This is a client
    // used for sending emails. It can be expanded to retrieve emails as 
    // well.
    // 
    // The Web application has an administrative view the will be used 
    // for sending emails from the notification view. In addition to the 
    // notifications view, a daemon can send notifications by posting to 
    // this web service as well. 
    // 
    // The emails being sent are past in the post as a data object as 
    // defined in lib/dataStructs.js module.
    //-----------------------------------------------------------------------
    // Check authentication of user and the request type, if not authenticated
    // the script will terminate execution with continuing to execute the 
    // following code.
    require_once 'authenticate.php';

    // When getting here the user and request has been authenticated
    // Get the database connection and api with action types (command)
    include_once('../includes/config.php');

    // Retrieve the jason data passed in the post.
    $str_json = file_get_contents('php://input');
    // Convert the jason data to an associative array.
    $dataArray = json_decode($str_json, true);


    require 'PHPMailerAutoload.php';

    $mail = new PHPMailer;

    // Get the settings from the database
    $query = $NONE;
    $result = null;

    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);


    $query = "SELECT * FROM mailsettings ORDER BY ServerType LIMIT 1";
    $result = $mysqli->query($query);
    if ($result != null && $result->num_rows > 0) {
        // Retrieve the data from the query result
        $setting = array();
        $setting = $result->fetch_assoc();

        switch ($setting['ServerType']) {
            case 0:
                // Set mailer to use SMTP 
                $mail->isSMTP();
                break;
            case 1:
                // Set mailer to use php mail 
                $mail->isMail();
                break;
            case 2:
                // Set mailer to use Sendmail 
                $mail->isSendmail();
                break;
            case 3:
                // Set mailer to use Qmail 
                $mail->isQmail();
                break;
            default:
                // Default to no email 
                $response = array();
                $response['status'] = "error";
                $response['message'] = "No Email server configured!";
                $json_response = json_encode($response);
                echo $json_response;
                exit;
                break;
        }
        // SMTP authentication enable setting
        $mail->SMTPAuth = $setting['SMTPAuth'];
        // tls or ssl encryption
        $mail->SMTPSecure = $setting['SMTPSecure'];
        // set the SMTP server, lss web server's address
        $mail->Host = $setting['HostName'];
        // TCP port to connect to, SMTP server
        $mail->Port = $setting['Port'];

        // This application's user information
        // SMTP server/client username
        $mail->Username = $setting['Username'];
        // SMTP server/client password
        $mail->Password = $setting['Password'];
    } else {

        // The following settings are the defaults.....
        // $mail->isSMTP();     // Set mailer to use SMTP
        $mail->isMail();        // Set mailer to use php mail
        // $mail->isSendmail(); // Set mailer to use Sendmail
        // $mail->isQmail();    // Set mailer to use Qmail

        $mail->SMTPDebug = 1;   // 0 = no output, 1 = errors and messages, 2 = messages only.

        $mail->SMTPAuth = false;                    // SMTP authentication enable setting
        $mail->SMTPSecure = 'tls';                  // Enable TLS encryption, `ssl` also accepted
        $mail->Host = 'localhost.com';              // set the SMTP server
        $mail->Port = 25;                           // TCP port to connect to, SMTP server
        // This application's user information
        $mail->Username = 'root@localhost.com';     // SMTP server/client username
        $mail->Password = 'secret';                 // SMTP server/client password
    }

    // Email data from the service call
    // This will need to identify the user or LSS daemon.
    // Get the email source from the notification administrator.
    $query = "SELECT FromAddress, FromName From notificationadmin";
    $result = $mysqli->query($query);
    
    if($result != null && $result->num_rows > 0)
    {
        $mailFrom = array();
        $mailFrom = $result->fetch_assoc();

        $mail->From = $mailFrom['FromAddress'];
        $mail->FromName = $mailFrom['FromName'];
    }else{        
        $mail->From = $dataArray['From'];
        $mail->FromName = $dataArray['FromName'];     
    }
    
    $mail->addAddress($dataArray['To'], $dataArray['ToName']);     // Add a recipient

    $mail->isHTML($dataArray['isHTML']);
    $mail->Subject = $dataArray['Subject'];
    $mail->Body = $dataArray['Body'];
    $mail->AltBody = $dataArray['AltBody'];

    $response = array();
    if (!$mail->send()) {
        $response['status'] = "error";
        $response['message'] = "Email action failed. Message:" . $mail->ErrorInfo;
    } else {
        $response['status'] = "success";
        $response['message'] = "Email successfully sent.";
    }
    // Encode the response
    $json_response = json_encode($response);
    // # Return the response
    echo $json_response;

?>
