<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/
   //-----------------------------------------------------------------------
   // mailSettings
   // 
   // Updates and retrieves the current phpMailer settings. The client
   // service will post a command with settings data structure that is
   // received in the request. The received data is then converted to an
   // associated array that will match the EmailSettingsStruct with the
   // key(s) matching the defined properties.
   //-----------------------------------------------------------------------
    // Check authentication of user and the request type, if not authenticated
    // the script will terminate execution with continuing to execute the 
    // following code.
    require_once 'authenticate.php';

    // When getting here the user and request has been authenticated
    // Get the Database configuration.
    include_once('../includes/config.php');
    // Check if user has access
    HasAccess(USER_ADMIN, true);

    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    // Retrieve the jason data passed in the post.
    $str_json = file_get_contents('php://input');
    // Convert the jason data to an associative array.
    $dataArray = json_decode($str_json, true);

    $query = $NONE;
    $result = null;

    // Process the request type
    if($dataArray['command']== $DB_CMD_GET_SETTINGS)
    {
        $query="SELECT DISTINCT ServerType,SMTPAuth,SMTPSecure,".
               "Hostname,Port,UserName,Password ".
               "FROM mailsettings LIMIT 1";
        $result = $mysqli->query($query);
        if($result == null || $result->num_rows === 0)
        {
            $response = array();
            $response['status']  = "error";
            $response['message'] = "Failed to retrieve data, record not found.";
            // Encode the response
            $json_response = json_encode($response);
        }else{        
            $arr = array();
            if($result->num_rows > 0) {
                while($row = $result->fetch_assoc()) {
                    $arr[] = $row;	
                }
            }
            // JSON-encode the response
            $json_response = json_encode($arr);

        }
        // Return the response
        echo $json_response;
    }
    elseif ($dataArray['command']==$DB_CMD_SET_SETTINGS) { 
        if($dataArray['SMTPAuth']){
            $Auth = 1;
        } else {
            $Auth = 0;
        }
        
        $query="UPDATE mailsettings SET ".
               "ServerType=".$dataArray['ServerType'].",".
               "SMTPAuth=".$Auth.",".
               "SMTPSecure=\"".$dataArray['SMTPSecure']."\",".
               "HostName=\"".$dataArray['HostName']."\",".
               "Port=".$dataArray['Port'].",".
               "Username=\"".$dataArray['Username']."\",".
               "Password=\"".$dataArray['Password']."\" ".
               "LIMIT 1";
        $result = $mysqli->query($query);
        // Check the result and return status 
        $response = array();
        if($result === null || $result === false)
        {
            $response['status']  = "error";
            $response['message'] = "Update action failed, record not found.";
        }else{
            $response['status']  = "success";
            $response['message'] = "Settings successfully updated.";
        }
        // Encode the response
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
    };


?>
