<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/
    //-----------------------------------------------------------------------
    // requestNotifications.php
    // 
    // The client will post a database action type (command) to perform. 
    // The actions are defined in lib/appEnum and are used by the controller
    // and service to send it to this server side php service as a post.
    //
    // This will retrieve notifications that are logged in the database. The
    // user will be capable of reviewing the notifications sent.
    //-----------------------------------------------------------------------
    // Check authentication of user and the request type, if not authenticated
    // the script will terminate execution with continuing to execute the 
    // following code.
    require_once 'authenticate.php';
    // When getting here the user and request has been authenticated
    // Get the Database configuration.
    include_once('../includes/config.php');
    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    // Retrieve the jason data passed in the post.
    $str_json = file_get_contents('php://input');
    // Convert the jason data to an associative array.
    $dataArray = json_decode($str_json, true);

    $query = $NONE;
    $result = null;

    // Process the service request type
    switch($dataArray['command'])
    {
        //
        case $DB_CMD_ALL_NOTIFICATIONS:
            break;
    };

    //-----------------------------------------------------------------------
    // ProcessQueryResultsRaw
    //
    // This will return the results without further processing.
    //-----------------------------------------------------------------------
    function ProcessQueryResultsRaw($result)
    {
        if($result == null)
        {
            $response = array();
            $response['status']  = "error";
            $response['message'] = "Failed to retrieve data, record not found.";
            // Encode the response
            $json_response = json_encode($response);
        }else{        
            $arr = array();
            if($result->num_rows > 0) {
                while($row = $result->fetch_assoc()) {
                    $arr[] = $row;	
                }
            }
            # JSON-encode the response
            $json_response = json_encode($arr);

        }
        // # Return the response
        echo $json_response;
    }
    

    
?>