<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/

    //-----------------------------------------------------------------------
    // updateData
    // 
    // The client will post a database action type (command) to perform. 
    // The actions are defined in lib/appEnum and are used by the controller
    // and service to send it to this service as a http post message.
    // 
    // In the service, then client side javascript, the command and parameters
    // are json encoded that is then coverted into a string and passed in
    // the post request. The command type and parameters are used for 
    // determining the database query action. The actions are insert
    // queries.
    //-----------------------------------------------------------------------
    // Security check
    require_once 'authenticate.php';
    $UserLevel = intval($_SESSION['Level']);
    // Get the database connection and api with action types (command)
    include_once('../includes/config.php');

    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    
    $result = null;
    
    // We only process a post request !
    if($_SERVER['REQUEST_METHOD'] == "POST"){
        // Retrieve the jason data passed in the post.
        $str_json = file_get_contents('php://input');
        // Convert the jason data to an associative array.
        $dataArray = json_decode($str_json, true);
        
        $query = $NONE;
        $result = null;
        
        // Process the service request type
        switch($dataArray['command'])
        {
            case $DB_CMD_UPDATE_USER:
                $query="UPDATE users SET ".
                    "UserName=\"".$dataArray['Name']."\",".
                    "NotificationType=".$dataArray['Notify'].",".
                    "Email=\"".$dataArray['Email']."\",".
                    "Phone=\"".$dataArray['Phone']."\"";
                    if($UserLevel>USER_USER){
                        $query.=",Company=\"".$dataArray['Company']."\"";
                        if($UserLevel>=$dataArray['Level']){
                            $query.=",Level=".$dataArray['Level'];
                        }
                    }
                    $query.=" WHERE UID=".$dataArray['UID'];
                $result = $mysqli->query($query);
                ProcessQueryResult($result, false);
                break;
            case $DB_CMD_UPDATE_GROUPS:
                if($UserLevel >= USER_MANAGER){
                    $query="UPDATE groups SET ".
                           "PID=\"".$dataArray['PID']."\",".
                           "GroupName=\"".$dataArray['GroupName']."\",".
                           "OrgKey=\"".$dataArray['OrgKey']."\" ".
                           "WHERE GID=".$dataArray['GID'];
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result, false);
                }else{
                    ProcessQueryResult(null, true); 
                }                
               break;
            case $DB_CMD_UPDATE_THEATERGROUPS:
                if($UserLevel >= USER_MANAGER){
                    $query="UPDATE theatergroups SET ".
                           "TheaterNumber=\"".$dataArray['TheaterNumber']."\",".
                           "OrgKey=\"".$dataArray['OrgKey']."\",".
                           "GroupID=".$dataArray['GroupId']." ".
                           "WHERE TGID=".$dataArray['TGID'];
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result, false);
                }else{
                    ProcessQueryResult(null, true); 
                }               
                break;
            case $DB_CMD_UPDATE_USERGROUPS:
                if($UserLevel >= USER_MANAGER){
                    $query="UPDATE usergroups SET ".
                           "UserID=".$dataArray['UserId'].",".
                           "GroupID=".$dataArray['GroupId'].",".
                           "Active=".$dataArray['Active']." ".
                           "WHERE UGID=".$dataArray['UGID'];
                    $result = $mysqli->query($query);
                    ProcessQueryResult($result, false);                     
                }else{
                    ProcessQueryResult(null, true); 
                }               
                break;
            default:
                ProcessQueryResult(false, false);
                break;                
        }
        
    }
    
    //-----------------------------------------------------------------------
    // ProcessQueryResult
    //
    // This will return the results without further processing. I 
    // text message is provided show an info box.
    //-----------------------------------------------------------------------
    function ProcessQueryResult($result, $noAccess)
    {
        $response = array();        
        if($noAccess === true)
        {
            $response['status']  = "info";
            $response['message'] = "Access Denied, Insufficient user priviledges, see manager or administrator";
        }else if($result === null || $result === false){
            $response['status']  = "error";
            $response['message'] = "Update action failed, record not found.";
        }else{
            $response['status']  = "success";
            $response['message'] = "Item successfully updated.";
        }
        // Encode the response
        $json_response = json_encode($response);
        // # Return the response
        echo $json_response;
    }

?>
