/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// dbAdminService
// 
// There are two tables that grow overtime and require periodic maintence. 
// The RawData and Notification tables are updated daily from LSS-100P
// measurement results postings.
// 
//---------------------------------------------------------------------------
app.service('dbAdminService', function ($http, Data) {

    
    this.dbAdmin = function (result, cmdToken, value1, value2) {
        console.log("dbAdminService: post command = "+cmdToken); 
        // The command and parameters are passed the service via 
        // a post.
        var jsonCmdObj = {"command":cmdToken,
                          "param1":value1,
                          "param2":value2}; 
        
        var cmdData = JSON.stringify(jsonCmdObj);
        //console.log("AJAX server request "+JSON.stringify(jsonCmdObj)); //For Debugging
        $http.post('serverservices/databaseAdmin.php', cmdData).success(function(data){
            if(data.status === 'error')
                Data.toast(data);
            else
            {
                switch(cmdToken)
                {
                    case EnumDBAdminCmds.RAWDATA_STATISTICS:
                        statusItem = new TableStatusStruct();
                        statusItem.count = parseInt(data.count);
                        var dt = new Date();
                        var offset = dt.getTimezoneOffset()*60;
                        statusItem.newest = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data.newestDate)+offset)*1000));
                        statusItem.oldest = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data.oldestDate)+offset)*1000));
                        result.push(statusItem);
                        break;
                    case EnumDBAdminCmds.NOTIFICATION_STATISTICS:
                        statusItem = new TableStatusStruct();
                        statusItem.count = parseInt(data.count);
                        var dt = new Date();
                        var offset = dt.getTimezoneOffset()*60;
                        statusItem.newest = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data.newestDate)+offset)*1000));
                        statusItem.oldest = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data.oldestDate)+offset)*1000));
                        result.push(statusItem);
                        break;
                    case EnumDBAdminCmds.NOTIFICATIONS_PENDING_COUNT:
                        result.Integer = data.Count;
                        break;
                    case EnumDBAdminCmds.NOTIFICATION_ERROR_COUNT:
                        result.Integer = data.Count;
                        break;
                    case EnumDBAdminCmds.NOTIFICATION_ERROR_ENTRIES:
                        var dt = new Date();
                        var offset = dt.getTimezoneOffset()*60;
                        for (var i in data)
                        {   
                            notification = new NotificationDbAdminStruct();
                            notification.id = data[i].id;
                            notification.RawDataId = data[i].RawDataId;
                            notification.ReceivedDateTime = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data[i].ReceivedDateTime)+offset)*1000));
                            notification.Email = data[i].Email;
                            notification.SentDateTime = data[i].SentDateTime == -1 ? "Email Error":"No User";
                            result.push(statusItem);
                        }
                        break;
                    case EnumDBAdminCmds.NOTIFICATIONS_PENDING_DELETE:
                        result.Boolean = data.Result;
                        break;
                    case EnumDBAdminCmds.RAWDATA_DELETE:
                        result.Boolean = data.Result;
                        break;
                    case EnumDBAdminCmds.NOTIFICATIONS_DELETE:
                        result.Boolean = data.Result;
                        break; 
                    case EnumDBAdminCmds.RAWDATA:
                        var dt = new Date();
                        var tz = dt.getTimezoneOffset();
                        var offset = dt.getTimezoneOffset()*60;
                        for (var i in data)
                        {
                           lssRawData = new RawDataDbAdminStruct();
                           lssRawData.id = parseInt(data[i].id);
                           lssRawData.OrgKey = data[i].OrgKey;
                           lssRawData.DateTime = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data[i].DateTime)+offset)*1000));
                           lssRawData.TheaterNumber = parseInt(data[i].TheaterNumber);
                           result.push(lssRawData);
                        }  
                        break;
                    case EnumDBAdminCmds.NOTIFICATIONS:
                        var dt = new Date();
                        var offset = dt.getTimezoneOffset()*60;
                        for (var i in data)
                        {
                            notification = new NotificationDbAdminStruct();
                            notification.id = parseInt(data[i].id);
                            notification.RawDataId = parseInt(data[i].RawDataId);
                            notification.ReceivedDateTime = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data[i].ReceivedDateTime)+offset)*1000));
                            notification.Email = data[i].Email;
                            // Convert the Sent Date to a response
                            var sentStatus = parseInt(data[i].SentDateTime);
                            if(sentStatus > 0)
                                notification.SentDateTime = d3.time.format("%Y-%m-%d %H:%M%:%S")(new Date((parseInt(data[i].SentDateTime))*1000)); 
                            else if(sentStatus == 0)
                                notification.SentDateTime  = 'Email Pending';
                            else if(sentStatus == -1)
                                notification.SentDateTime = 'Email Error';
                            else
                                notification.SentDateTime = 'No User';
                            // Add to returned collection, array 
                            result.push(notification);
                        }
                        break;
                    case EnumDBAdminCmds.COMPANIES:
                        // Shield your eyes on the fly definition
                        function ac(){this.Company};
                        for (var i in data)
                        {
                            var item = new ac();
                            item.Company = data[i].company;
                            result.push(item);
                        }
                        break;
                }
            }
        }).error(function(data){
            console.log('dbRequestService: Error '+data);
        });
    };
});