//---------------------------------------------------------------------------
// notificationService
// 
// Send mail service, the mailItem is an EmailMessageStruct object that
// contains address and message body text to be emailed. 
//---------------------------------------------------------------------------
app.service('notificationService', function ($http, Data) {

    this.getSettings = function (notificationSettings){      
        // Create the command type.
        var jsonCmdObj = {"command":EnumNotificationSettingCmds.GET};
        // Create the stinge that sent with the post.
        var cmd = JSON.stringify(jsonCmdObj);
        // Send server request
        $http.post('serverservices/notificationAdmin.php', cmd).success(function(data){
            if(data.status === 'error')
                Data.toast(data);
            else
            {   
                if(data.length > 0)
                {
                    // Convert the int value to boolean type
                    if(parseInt(data[0].Running)>0)
                        notificationSettings.Running = true;
                    else
                        notificationSettings.Running = false;
                    
                    notificationSettings.StatusText   = data[0].StatusText;
                    // Convert from epoch to datatime epoch is seconds from php
                    // Web service and java script is millisonds.
                    var lastCronRunSecs = parseInt(data[0].LastCronRun);
                    if(lastCronRunSecs > 0)                    
                        notificationSettings.LastCronRun  = new Date(lastCronRunSecs*1000);
                    
                    notificationSettings.Errors       = parseInt(data[0].Errors);
                    notificationSettings.IntervaluSecs = parseInt(data[0].IntervaluSecs);
                    notificationSettings.DomainNameServer  = data[0].DomainNameServer;
                    notificationSettings.FromAddress       = data[0].FromAddress;
                    notificationSettings.FromName          = data[0].FromName;
                    notificationSettings.LastSent          = parseInt(data[0].LastSent);
                    notificationSettings.Valid             = true;
                };
                
            };
        }).error(function(results){
            Data.toast(results);
        });
    };

    this.setSettings = function (notificationSettings) {
        // Create the command type.
        var jsonCmdObj = {"command":EnumNotificationSettingCmds.SET};
       
        var cmdAndData = JSON.stringify(jsonCmdObj);
        var cmdData = JSON.stringify(notificationSettings);
        // Trim the command  and data strings to append.
        cmdData = cmdData.substr(1);
        cmdAndData = cmdAndData.substr(0, cmdAndData.length-1);
        cmdAndData += ','+cmdData;
        // Send server request
        $http.post('serverservices/notificationAdmin.php', cmdAndData).success(function(results){
            Data.toast(results);
        }).error(function(results){
            Data.toast(results);
        });
    };
    
    this.testCron = function (notificationSettings){
        var self = this;
        $http.post('serverservices/cronTest.php').success(function(results){
            Data.toast(results);
            self.getSettings(notificationSettings);
        }).error(function(results){
            Data.toast(results);
            self.getSettings(notificationSettings);
        });        
    };
    
});


