#!/usr/bin/python
'''
Loads or compares the files for the lssdb product
Created on Oct 23, 2015

@author: MTA
'''

import os
import subprocess
import tarfile
import GlobalVars as gv
import AnsiColor as ac

def lprint( text, printtoo = True ):
    if( printtoo ):
        print( text )
    try:
        gv.LogFileHandle.write( text + "\n" )
    except:
        return


def FileOps():
    global gv
    fileop = ""
    if( gv.sysPlatform == 'Windows' ):
        cmd = "dir c:\\" + gv.sampleFile + " /B/S"
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        output = p.stdout.read()
        if output.find( "Not Found" ) > 0:
            output = ""
            try:
                cmd = "dir d:\\" + gv.sampleFile + " /B/S"
                p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                output = p.stdout.read()
                if output.find( "Not Found" ) > 0:
                    output = ""
            except:
                pass
        output = output.replace( "\\", "/" ).lower()
        lout = output.split( "\n" )
        for item in lout:
            if item.find( gv.InstalledPath + gv.lssRoot + gv.sampleFilePath + gv.sampleFile ) >= 0:
                output = item
                break
        output = output.replace( "\\", "/" ).lower()
    else:
        cmd = "find / -name " + gv.sampleFile
        if gv.distribution == "Ubuntu":
            cmd = "echo %s | sudo -S find / -name " + gv.sampleFile
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        output = p.stdout.read()
        # Do the following for permission denied problems on some systems
        filelist = output.split( "\n" )
        for item in filelist:
            if item.find( gv.sampleFile ) > 0:
                output = item
                break
    if( output.find( gv.sampleFile ) >= 0 ):
        # We have an existing folder with lssdb in it.
        # See if it's in the specified location
        if( output.find( gv.lssRoot.lower() ) >= 0 ):
            fullpath = output[0:output.find( gv.lssRoot.lower() )] + gv.lssRoot
            lprint( "Web Root matches the located file root at: %s" % fullpath )
            lprint( "Comparing files to determine if latest revision." )
            fileop = "compare"
            gv.InstalledPath = fullpath  # Save path where LssDB is installed for later tests
        else:
            # We have to move to the users new root
            gv.lssRoot = output.replace( gv.sampleFilePath + gv.sampleFile, "" )
            fullpath = gv.lssRoot
            lprint( "Web Root where files were located: %s" % fullpath )
            fileop = "compare"
    else:
        # No existing lssdb is on the drive.
        lprint( "No lssdb web collection found." )
        # Look for the best place to put it
        if( gv.sysPlatform == 'Windows' ):
            cmd = "dir c:\\" + gv.InstalledPath + " /B/S/AD"
        else:
            cmd = "find / -type d -name " + gv.InstalledPath
        if gv.distribution == "Ubuntu":
            cmd = "echo %s | sudo -S find / -name " + gv.InstalledPath
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        output = p.stdout.read()
        # For windows clean up directory list
        output = output.replace( "\\", "/" ).lower()
        output = output.replace( "\r", "" )
        # In case there are several paths we will pick the shortest and ask the user
        paths = output[0:output.rfind( "\n" )].split( "\n" )
        if( len( paths ) == 0 ):
            paths[0] = gv.InstalledPath
        targetpath = paths[0]
        for item in paths:
            if( len( item ) < len( targetpath ) ):
                targetpath = item
        ok = 1
        while( ok == 1 ):
            # To accept a \ character in case user mixes path separators we use a try catch method
            try:
                response = raw_input( "OK to install in " + targetpath + " [y/N/newpath]? " )
            except:
                pass
            response = response.replace( "\\", "/" )
            if( len( response ) <> 0 ):
                if( response.find( "/" ) >= 0 ):  # We have a new path. Ask again
                    targetpath = response
                elif response[0].upper() == "Y":
                    ok = 2
            else:
                ok = 0
                fileop = "NO_DICE"
        if( ok == 2 ):
            fileop = "install"
            fullpath = targetpath + gv.lssRoot
            lprint( "Installing at: %s" % fullpath )


    if( fileop == 'compare' ):
        tar = tarfile.open( gv.WorkingDir + "/" + gv.setuptarfile, "r:gz" )
        collection = tar.getmembers()
        for member in collection:
            if( member.name.find( gv.tarWebFolder ) >= 0 ):
                if ( member.isfile() ):
                    filepathname = member.name[member.name.find( "/" ):]
                    text = "File: %s" % ( filepathname )
                    tarFile = tar.extractfile( member ).read()
                    # print "fullpath: %s  filepathname: %s" % ( fullpath , filepathname )
                    # Do a try and catch in case the file does not exist
                    try:
                        webfilehandle = open( fullpath + filepathname, "rb" )
                        webFile = webfilehandle.read()
                        webfilehandle.close()
                    except:
                        response = raw_input( "There as a problem locating the file. Replace with new one? [yN]" )
                        if len( response ) > 0:
                            if response[0].lower() == "y":
                                webfilehandle = open( fullpath + filepathname, "wb" )
                                webfilehandle.write( tarFile )
                                # webFile = webfilehandle.read()
                                webFile = tarFile
                                webfilehandle.close()
                                lprint( fullpath + filepathname + " has missing and has been replaced." )
                            else:
                                webFile = ""
                                lprint( fullpath + filepathname + " has missing and was not replaced." )
                    if webFile <> tarFile:
                        text1 = text + " Does not compare."
                        lprint( text1, False )
                        ac.cprint( text1, ac.RED )
                        ac.cprint( "Would you like to replace the old file with the new file ", ac.WHITE, False )
                        response = raw_input( "[yN]" )
                        if len( response ) > 0:
                            if response[0].lower() == "y":
                                lprint( "Overwriting %s. Archive size %d, disk size %d" % ( text, len( tarFile ), len( webFile ) ) )
                                writefilehandle = open( fullpath + member.name[len( gv.tarWebFolder ):], "wb" )
                                writefilehandle.write( tarFile )
                                writefilehandle.close()
                            else:
                                lprint( text + " was not replaced." )
                        else:
                            lprint( text + " was not replaced." )
                    else:
                        lprint( text + " Compares." )

    elif( fileop == 'install' ):
        # Try and make the root directory.  Pass if already there.
        try:
            if( gv.sysPlatform == 'Windows' ):
                os.mkdir( fullpath )
            else:
                try:
                    lprint( "Attempting to create %s using system command mkdir" % fullpath )
                    cmd = "mkdir %s -m 777" % fullpath
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    print p.stdout.read()
                    p.wait()
                except:
                    lprint( "Attempting to create %s using system command sudo mkdir" % fullpath )
                    cmd = "echo %s | sudo -S mkdir %s -m 777" % ( gv.suPassword, fullpath )
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    print p.stdout.read()
                    p.wait()
        except:
            pass
        tar = tarfile.open( gv.WorkingDir + "/" + gv.setuptarfile, "r:gz" )
        collection = tar.getmembers()
        for member in collection:
            if( member.name.find( gv.tarWebFolder ) >= 0 ):
                if ( member.isfile() ):
                    filepathname = member.name[member.name.find( "/" ):]
                    text = "File: %s" % ( filepathname )
                    newtarFile = tar.extractfile( member ).read()
                    webfilehandle = open( fullpath + filepathname, "wb" )
                    webFile = webfilehandle.write( newtarFile )
                    webfilehandle.close()
                    lprint( text + " written." )
                elif( member.isdir() ):
                    if member.name <> gv.tarWebFolder:
                        # Use try in case directory is already there
                        try:
                            os.mkdir( fullpath + member.name.replace( gv.tarWebFolder, "" ) )
                        except:
                            pass


    lprint( "File Operations complete" )

def main():
    gv.init()
    print "Performing DBoperations in stand alone mode."
    try:
        gv.LogFileHandle = open( "lssdb_log.txt", "w" )
    except:
        print "Unable to open log file. Continuing without."
    try:
        FileOps()
    except KeyboardInterrupt:
        gv.LogFileHandle.close()
        exit()
    gv.LogFileHandle.close()
    print "Program completed normally."

if __name__ == '__main__':
    try:
        main()
    except:
        raise


