#!/usr/bin/python
'''
Created on Sep 10, 2015

@author: MTA
'''
from __builtin__ import False
"""-------------------- INSTALL OPERATIONS ------------------------
On CENTOS: sudo yum install mysql-server
           sudo yum install httpd
           
           
-----------------------------------------------------------------"""

import AnsiColor as ac
import GlobalVars as gv
import os, signal
import platform
from time import sleep
import subprocess
import sys

LogFileHandle = None

def linux_distribution():
    try:
        return platform.linux_distribution()
    except:
        return "N/A"

def lprint( text, printtoo = True ):
    if( printtoo ):
        print( text )
    try:
        gv.LogFileHandle.write( text + "\n" )
    except:
        return

def GetInfo():
    global gv
    # print "Globals:", gv.distribution, gv.sysPlatform, gv.LogFileHandle
    pythonVersion = sys.version.split( '\n' )
    gv.sysPlatform = platform.system()  # Linux or Windows
    gv.distribution = "windows"
    lprint( "Python version: %s" % pythonVersion )
    if platform.dist()[0] <> '':
        lprint( "Platform Distribution: %s" % str( platform.dist()[0] ) )
        gv.distribution = platform.dist()[0]  # centos, debian, redhat, etc
    if linux_distribution()[0] <> '':
        lprint( "Linux Distribution: %s Version: %s" % ( linux_distribution()[0], linux_distribution()[1] ) )
    if gv.sysPlatform <> '':
        lprint( "Operating System: %s" % gv.sysPlatform )
    if platform.machine() <> '':
        lprint( "Machine: %s" % platform.machine() )
    if platform.platform() <> '':
        lprint( "OS Platform: %s" % platform.platform() )
    if platform.version() <> '':
        lprint( "Version: %s" % platform.version() )
    if platform.uname()[0] <> '':
        lprint( "Details: %s %s %s %s %s %s" % platform.uname() )
    if platform.mac_ver()[0] <> '':
        lprint( "Macintosh Platform: %s" % platform.mac_ver() )

    # Check for the presence of MySQL on windows.  We have to find the path to get the version
    # On Linux systems MySQL is in path so we can just use the command to see if it is there.
    if gv.sysPlatform == "Windows":
        print "Checking for MySQL on windows."
        mysqlpresent = True
        cmd = "dir c:\*mysqld.exe /S /B"
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        output = p.stdout.read()
        if output.find( "File Not Found" ) >= 0:
            cmd = "dir d:\*mysqld.exe /S /B"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            output = p.stdout.read()
            if( output.find( "File Not Found" ) >= 0 or output.find( "The " ) == 0 ):
                mysqlpresent = False
                lprint( "The system does not have MySQL installed." )
        if mysqlpresent:
            result = output.split( "\n" )
            print "MySQL found at: %s" % result[0]
            # Using the path, get the version of MySQL
            # Set the path first because the subprocess cannot handle spaces in path names
            # Change separators so they don't look like escapes
            # Now isolate only the path
            path = result[0][0:result[0].rfind( '\\' )]
            os.chdir( path )
            cmd = "mysql.exe -V"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            mySqlVersion = p.stdout.read()
            lprint( "Returned Version: %s" % mySqlVersion )

            # Start up the server in case it's stopped
            cmd = "mysqld.exe --console"
            mySqlProc = subprocess.Popen( cmd, shell = False, stdout = subprocess.PIPE )
            mySqlPid = mySqlProc.pid
            os.kill( mySqlPid, signal.SIGTERM )
            #
            # MySQL is present in operating system, we need to set it up

        print "Looking for Apache!"
        cmd = "dir c:\*httpd.exe /S /B"
        apachepresent = True
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        output = p.stdout.read()
        if output.find( "File Not Found" ) >= 0:
            cmd = "dir d:\*httpd.exe /S /B"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            output = p.stdout.read()
            if( output.find( "File Not Found" ) >= 0 or output.find( "The " ) == 0 ):
                apachepresent = False
                lprint( "The system does not have Apache installed." )
        if apachepresent:
            result = output.split( "\n" )
            # Found Apache now let's check version
            lprint( output )
            # Now isolate only the path
            path = result[0][0:result[0].rfind( '\\' )]
            lprint( "Apache found in folder: %s" % path )
            os.chdir( path )
            cmd = "httpd.exe -v"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            myApacheVersion = p.stdout.read()
            print myApacheVersion
            # Now check installed modules to see if HTTPS can be used
            cmd = "httpd.exe -M"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            installedModules = p.stdout.read()
            lprint( installedModules )
            if installedModules.find( "ssl_module" ):
                ac.cprint( "Apache has the correct module for HTTPS if desired.", ac.GREEN )
            else:
                ac.cprint( "If HTTPS is desired please install Apache module: ssl_module" )
            # Check for undefined Domain Name
            if( installedModules.find( "AH00558" ) > 0 ):
                text = "The default Domain Name is not defined!"
                ac.cprint( text, ac.YELLOW )
                ac.cprint( "You must define a default Domain Name in Apache and rerun this program.", ac.YELLOW )
                lprint( text, False )
            # Now check the paths to see where the config files are located
            # NOTE: on Linux, version gives default paths. On Windows see need to look
            print "Checking for httpd.conf file."
            cmd = "dir " + path[0:path.rfind( "\\" )] + "\*httpd.conf /S /B"
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            output = p.stdout.read()
            output = output.split( "\n" )
            path = output[0][0:output[0].rfind( "\\" ) + 1]
            try:
                os.chdir( path )
                fh = open( "httpd.conf", "r" )
                conf = fh.read()
                fh.close()
                lprint( "httpd.conf found in folder: %s" % path )
            except:
                conf = ""
                lprint( "Apache configuration file not found." )
            if( len( conf ) ):
                ptr1 = conf.find( "\nServerName" )
                if( ptr1 ):
                    ptr2 = conf[ptr1 + 1:].find( "\n" ) + 1
                    # '\nServerName' = 11 chars
                    sn = conf[ptr1 + 11:ptr2].strip()
                    if( sn.find( "." ) ):
                        msg = "The current ServerName: " + sn + "appears to be a qualified domain name."
                    else:
                        msg = "The current ServerName: " + sn + " is not a qualified domain name.\nThis may cause problems adding lssdb website."
                else:
                    msg = "'ServerName' could not be found in the httpd.conf file."
            else:
                msg = "httpd.conf could not be found.  Please check to make sure Apache is correctly installed."
            print msg

    if gv.sysPlatform == "Linux":
        installdb = True
        while installdb:
            print "Checking for MySQL on Linux."
            mysqlpresent = False
            maria = False
            cmd = "find / -noleaf -type f -name mysqld"
            if gv.distribution == "Ubuntu":
                cmd = "echo %s | sudo -S find / -noleaf -type f -name mysqld" % gv.suPassword
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            output = p.stdout.read()
            p.wait()
            print output
            if len( output ) > 0:
                mysqlpresent = True
            else:
                # Check if Maria is installed
                print "MySQL not found. Checking for MariaDB."
                cmd = "find / -noleaf -type f -name mariadb"
                if gv.distribution == "Ubuntu":
                    cmd = "echo %s | sudo -S find / -noleaf -type f -name mariadb" % gv.suPassword
                p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                output = p.stdout.read()
                p.wait()
                print output
                if len( output ) > 0:
                    maria = True
            if( mysqlpresent or maria ):
                result = output.split( "\n" )
                path = result[0]
                # We may or my not have the true executable. It could be a spoof.
                # Using the path, get the version of MySQL
                # Set the path first because the subprocess cannot handle spaces in path names
                path = result[0]
                # Now isolate only the path
                path = path[0:path.rfind( "/" )]
                os.chdir( path )
                cmd = "mysql -V"
                p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                mySqlVersion = p.stdout.read()
                p.wait()
                if( mySqlVersion.find( "command not found" ) < 0 ):
                    ac.cprint( "MySQL found at: %s" % result[0] , ac.GREEN )
                    lprint( "Returned Version: %s" % mySqlVersion[0:mySqlVersion.rfind( ")" ) + 1] )
                    # Check if version is good enough for our use
                    # Note: MySQL and MariaDB versions 5.4, 5.5 are the same and good.
                    #       The newest release of MariaDB is in the 10.X category and
                    #       should be OK (10.1 was tested briefly during building this program)
                    #       since it maintains 5.5 functionality but adds more.
                    ptr1 = mySqlVersion.find( "Distrib" ) + 8
                    ptr2 = mySqlVersion[ptr1:].find( "-" ) + ptr1
                    mySqlVersion = mySqlVersion[ptr1:ptr2].split( "." )
                    if( mySqlVersion[0] == '5' ):
                        if ( int( mySqlVersion[1] ) >= 4 ):
                            ac.cprint( "This version of the database has been tested with this USL product.", ac.GREEN )
                        else:
                            ac.cprint( "This version of the database may cause problems and should be updated.", ac.RED )
                    if( mySqlVersion[0] == '10' ):
                        text = "This version of Maria was a release candidate during testing of this USL product.\n"
                        text += "It was not extensively tested with this product but should perform as needed.\n"
                        text += "Please notify USL if you encounter problems with this version."
                        ac.cprint( text, ac.YELLOW )

                    # Indicate database does not need to be installed
                    installdb = False
                    # Check to see if the service is running
                    print "Checking to see if MySQL service is active."
                    cmd = "service mysql status"
                    if( gv.distribution == 'centos' ):
                        cmd = 'systemctl status mariadb'
                    if( gv.distribution == 'fedora' ):
                        cmd = 'systemctl status mariadb'
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    status = p.stdout.read()
                    p.wait()
                    if( gv.distribution == 'centos' or gv.distribution == 'fedora' ):
                        ptr1 = status.find( "Active:" )
                        ptr2 = status[ptr1:].find( ")" ) + ptr1 + 1
                        status = status[ptr1:ptr2]
                        ac.cprint( "\t" + status )
                        if( status.find( "inactive" ) > 0 ):
                            print "Starting up stopped service."
                            # Start up the server in case it's stopped
                            cmd = 'sudo systemctl start mariadb'
                            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.PIPE )
                            result = p.stderr.read()
                            p.wait()
                            sleep( 2 )  # Need to wait some for CentOS as p.wait() does not seem to work for long commands
                            if( len( result ) == 0 ):
                                print "The service was successfully started."
                            else:
                                ac.cprint( "There is and error attempting to start the service.", ac.YELLOW )
                                ac.cprint( "Please insure service can start and rerun this program.", ac.YELLOW )
                                maria = False
                        else:
                            print "Maria is currently running as a service."
                    else:
                        # Debian type systems
                        ptr1 = status.find( "[info]" )
                        ptr2 = status[ptr1:].find( "\n" ) + ptr1
                        status = status[ptr1:ptr2]
                        ac.cprint( "\t" + status )
                        if( status.find( "stopped" ) > 0 ):
                            print "Starting up stopped service."
                            # Start up the server in case it's stopped
                            cmd = 'service mysql start'
                            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.PIPE )
                            result = p.stderr.read()
                            p.wait()
                            if result.find( "ok" ):
                                print "The service was successfully started."
                            else:
                                ac.cprint( "There is and error attempting to start the service.", ac.YELLOW )
                                ac.cprint( "Please insure service can start and rerun this program.", ac.YELLOW )
                                mysqlpresent = False
                        else:
                            print "MySQL is currently running as a service."

            # MySQL or Maria is not installed.  Can't do much until it is.
            else:
                text = "The system does not have MySQL installed."
                lprint( text, False )
                ac.cprint( text, ac.RED )
                interactive = False
                if( gv.distribution == 'centos' ):
                    method = 'sudo yum install mariadb-server'
                    cmd = 'sudo yum -y install mariadb-server'
                elif( gv.distribution == 'fedora' ):
                    method = 'dnf install mariadb-server'
                    cmd = 'dnf -y install mariadb-server'
                elif( gv.distribution == 'debian' ):
                    method = 'apt-get install mysql-server'
                    cmd = 'apt-get -y install mysql-server'
                elif( gv.distribution == 'Ubuntu' ):
                    method = 'sudo apt-get install mysql-server'
                    cmd1 = "echo mysql-server mysql-server/root_password password %s | sudo debconf-set-selections" % gv.suPassword
                    cmd2 = "echo mysql-server mysql-server/root_password_again password %s | sudo debconf-set-selections" % gv.suPassword
                    # cmd1 = """sudo debconf-set-selections <<< 'mysql-server mysql-server/root_password password %s'""" % gv.suPassword
                    # cmd2 = """sudo debconf-set-selections <<< 'mysql-server mysql-server/root_password_again password %s'""" % gv.suPassword
                    cmd = 'echo %s | sudo -S apt-get -y install mysql-server' % gv.suPassword
                    interactive = True
                ac.cprint( "Would you like to install the SQL server now?", ac.WHITE, False )
                response = raw_input( "[yN]" )
                if len( response ) > 0:
                    if response[0].lower() == "y":
                        lprint( "Installing SQL Server with command: %s" % method )
                        if interactive:
                            p = subprocess.Popen( cmd1, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                            status = p.stdout.read()
                            p.wait()
                            p = subprocess.Popen( cmd2, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                            status = p.stdout.read()
                            p.wait()
                        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        status = p.stdout.read()
                        p.wait()
                        lprint( status )
                else:
                    lprint( "User has decided to manually install SQL server.", False )
                    ac.cprint( "You must manually install the SQL Server." )
                    ac.cprint( "Suggested method: %s" % method )
                    ac.cprint( "Please install and run this program again.", ac.RED )
                    sys.exit()

        # Now check for Apache and allow user to install it if missing
        installApache = True
        while installApache:
            installApache = False
            if( gv.distribution == 'centos' ):
                httpinstallcmd = "sudo yum install httpd"
                httpcmd = "httpd"
                findcmd = "find / -noleaf -type f -name httpd"
            elif( gv.distribution == 'fedora' ):
                httpinstallcmd = "dnf install httpd"
                httpcmd = "httpd"
                findcmd = "find / -noleaf -type f -name httpd"
            elif( gv.distribution == 'Ubuntu' ):
                httpinstallcmd = "echo %s | sudo -S apt-get install apache2" % gv.suPassword
                httpcmd = "apache2ctl"
                findcmd = "echo %s | sudo -S find / -noleaf -type f -name apache2ctl" % gv.suPassword
            else:
                httpinstallcmd = "apt-get install apache2"
                httpcmd = "apache2ctl"
                findcmd = "find / -noleaf -type f -name apache2ctl"
            print "\nLooking for Apache!"
            p = subprocess.Popen( findcmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            output = p.stdout.read()
            p.wait()
            if ( len( output ) == 0 ) or ( output.find( "bin" ) < 0 ):
                text = "The system does not have Apache installed."
                lprint( text, False )
                ac.cprint( text, ac.RED )
                ac.cprint( "Would you like to install Apache now?", ac.WHITE, False )
                response = raw_input( "[yN]" )
                if len( response ) > 0:
                    if response[0].lower() == "y":
                        p = subprocess.Popen( httpinstallcmd + " -y", shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        output = p.stdout.read()
                        p.wait()
                        installApache = True
                    else:
                        response = ""

                if len( response ) == 0:
                    lprint( "User has decided to manually install the Apache Server.", False )
                    ac.cprint( "You must manually in the Apache Server." )
                    ac.cprint( "The suggested method to install is:  %s" % httpinstallcmd, ac.YELLOW )
                    ac.cprint( "Please install Apache and run this program again.", ac.RED )
                    sys.exit()
        else:
            path = output.split( "\n" )[0]
            # Found Apache now let's check version
            # Now isolate only the path
            path = path[0:path.rfind( "/" )]
            ac.cprint( "Apache found in folder: %s" % path, ac.GREEN )
            os.chdir( path )
            cmd = "%s -v" % httpcmd
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            myApacheVersion = p.stdout.read()
            lprint( myApacheVersion[0:myApacheVersion.rfind( "\n" )] )
            p.wait()
            # Now check installed modules to see if HTTPS can be used
            cmd = "%s -M" % httpcmd
            p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
            installedModules = p.stdout.read()
            p.wait()
            lprint( installedModules, False )
            # Check to ensure rewrte module is enabled
            if ( installedModules.find( "rewrite_module" ) > 0 ):
                ac.cprint( "Apache has the required rewrite_module enabled for LssDB use.", ac.GREEN )
            else:
                text = "Apache does not have the required rewrite_module enabled for LssDB use.\n"
                text += "It may be enabled using the command 'a2enmod rewrite'."
                ac.cprint( text, ac.RED )
                lprint( text, False )
                ac.cprint( "Enable rewrite_module now?", ac.WHITE, False )
                response = raw_input( "[yN]" )
                if len( response ) > 0:
                    if response[0].lower() == "y":
                        cmd = 'a2enmod rewrite'
                        if( gv.distribution == 'Ubuntu' ):
                            cmd = "echo %s | sudo -S a2enmod rewrite" % gv.suPassword
                        lprint( "Executing command: %s" % cmd )
                        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        installedModules = p.stdout.read()
                        p.wait()
                        cmd = 'service apache2 reload'
                        if( gv.distribution == 'Ubuntu' ):
                            cmd = "echo %s | sudo -S service apache2 reload" % gv.suPassword
                        lprint( "Executing command: %s" % cmd )
                        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        installedModules = p.stdout.read()
                        p.wait()
            # Check for modules to do HTTPS
            if installedModules.find( "ssl_module" ):
                ac.cprint( "Apache has the correct module for HTTPS if desired.", ac.GREEN )
            else:
                ac.cprint( "If HTTPS is desired please install Apache module: ssl_module" )
            # Check for undefined Domain Name
            if( installedModules.find( "AH00558" ) > 0 or installedModules.find( "using 127.0.1.1 for ServerName" ) > 0 ):
                text = "The default Domain Name is not defined!"
                ac.cprint( text, ac.YELLOW )
                ac.cprint( "You should define a default Domain Name in Apache.\nRunning without may cause problems.", ac.YELLOW )
                lprint( text, False )
            # Check Apache server status
            if( gv.distribution == 'centos' or gv.distribution == 'fedora' ):
                cmd = 'systemctl status httpd'
                p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                status = p.stdout.read()
                p.wait()
                ptr1 = status.find( "Active:" )
                ptr2 = status[ptr1:].find( ")" ) + ptr1 + 1
                status = status[ptr1:ptr2]
                ac.cprint( "\t" + status )
                if( status.find( "inactive" ) > 0 ):
                    print "Starting up stopped service."
                    # Start up the server in case it's stopped
                    cmd = 'systemctl start httpd'
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.PIPE )
                    result = p.stderr.read()
                    p.wait()
                    sleep( 2 )  # Need to wait some for CentOS as p.wait() does not seem to work for long commands
                    if( len( result ) == 0 ):
                        print "The service was successfully started."
                    else:
                        ac.cprint( "There is and error attempting to start the httpd service.", ac.YELLOW )
                        ac.cprint( "Please insure httpd service can start and rerun this program.", ac.YELLOW )
                else:
                    print "Apache (httpd) is currently running as a service."

            else:
                cmd = "service apache2 status"
                p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                status = p.stdout.read()
                p.wait()
                ptr1 = status.find( "Apache" )
                ptr2 = status[ptr1:].find( "\n" ) + ptr1
                status = status[ptr1:ptr2]
                ac.cprint( "\t" + status )
                if( status.find( "NOT" ) > 0 ):
                    print "Starting up stopped service."
                    # Start up the server in case it's stopped
                    cmd = 'service apache2 start'
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.PIPE )
                    result = p.stderr.read()
                    p.wait()
                    if result.find( "ok" ):
                        print "The Apache2 service was successfully started."
                    else:
                        ac.cprint( "There is and error attempting to start the Apache2 service.", ac.YELLOW )
                        ac.cprint( "Please insure service can start and rerun this program.", ac.YELLOW )
                else:
                    print "Apache2 is currently running as a service."
            # Now check the paths to see where the config files are located
            ptr1 = myApacheVersion.find( "" )
        # We are done here with checking Apache

        # Now check for PHP and PHP-mysql and allow user to install it if missing
        if gv.distribution == "debian":
            cmd1 = "apt-get -y install php"
            cmd2 = "apt-get -y install php-mysql"
            rcmd = "service apache2 restart"
        if gv.distribution == "Ubuntu":
            cmd1 = "echo %s | sudo -S apt-get -y install php5 libapache2-mod-php5 php5-mcrypt php5-cli"
            cmd2 = "echo %s | sudo -S apt-get -y install php5-mysql"
            rcmd = "echo %s | sudo -S service apache2 restart"
        elif gv.distribution == "fedora":
            cmd1 = "dnf -y install php"
            cmd2 = "dnf -y install php-mysql"
            rcmd = "systemctl restart httpd.service"
        else:
            cmd1 = "sudo yum -y install php"
            cmd2 = "sudo yum -y install php-mysql"
            rcmd = "systemctl restart httpd.service"
        # First check to see if PHP is present.  If so we can use it to get info on PHP-mysql
        cmd = "php -i"
        if( gv.distribution == 'Ubuntu' ):
            cmd = "echo %s | sudo -S php -i" % gv.suPassword
        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
        status = p.stdout.read()
        lprint( "*** PHP Information ***", False )
        lprint( status, False )
        p.wait()
        # A search for PHP Version in the output was added 1/15/16 becuase PHP -I will give a
        # No Such File error if one of its modules can't be found.  If we have PHP Version then we have php.
        if( ( status.find( "PHP Version" ) < 0 ) and
            ( ( status.find( "No such file or directory" ) >= 0 ) or
             ( status.find( "command not found" ) >= 0 ) or
             ( status.find( "not installed" ) >= 0 ) ) ):
            # PHP is missing we need to install both
            text = "PHP and PHP-mySQL are required but missing from this system."
            lprint( text, False )
            ac.cprint( text, ac.RED )
            ac.cprint( "Would you like to install PHP now?", ac.WHITE, False )
            response = raw_input( "[yN]" )
            if len( response ) > 0:
                if response[0].lower() == "y":
                    lprint( "Installing PHP" )
                    p = subprocess.Popen( cmd1, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    status = p.stdout.read()
                    p.wait()
                    lprint( status )
                    lprint ( "Installing PHP-mySQL" )
                    p = subprocess.Popen( cmd2, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    status = p.stdout.read()
                    p.wait()
                    lprint( status )
                    lprint( "Restarting Apache server." )
                    p = subprocess.Popen( rcmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    status = p.stdout.read()
                    p.wait()
                    lprint( status )
                    cmd = "php -i"
                    p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                    status = p.stdout.read()
                    p.wait()
                pass
            else:
                # Tell user how to install
                lprint( "User has elected to manually install PHP & PHP-mySQL." )
                ac.cprint( "The suggested command for PHP is: " + cmd1, ac.YELLOW )
                ac.cprint( "The suggested command for PHP-mySQL is: " + cmd2, ac.YELLOW )
                ac.cprint( "Please install both programs and run this program again.", ac.RED )
                sys.exit( 1 )
        else:  # We have PHP installed check version and if db connector is also installed
            ptr1 = status.find( "PHP Version" )
            ptr2 = status[ptr1:].find( "\n" )
            text = status[ptr1:ptr1 + ptr2]
            version = text.split( " " )
            nversion = version[3].split( "." )
            if int( nversion[0] ) == 5:
                ac.cprint( text, ac.GREEN )
                ac.cprint( "This version has been tested with the lssdb product.", ac.GREEN )
            elif int( nversion[0] ) < 5:
                ac.cprint( text, ac.RED )
                ac.cprint( "This version of PHP is too old and must be updated to operated correctly.", ac.RED )
            elif int( nversion[0] ) > 5:
                ac.cprint( text, ac.YELLOW )
                ac.cprint( "This version of PHP is newer than the tested version but should operate correctly.", ac.YELLOW )
            # Now check for php-mysql connector
            ptr1 = status.find( "MySQL Support" )
            while ptr1 < 0 :
                text = "There is no php-mysql support for this PHP install."
                lprint( text, False )
                ac.cprint( text, ac.RED )
                ac.cprint( "Would you like to install php-mysql now?", ac.WHITE, False )
                response = raw_input( "[yN]" )
                if len( response ) > 0:
                    if response[0].lower() == "y":
                        lprint( "Installing PHP-mySQL" )
                        p = subprocess.Popen( cmd2, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        status = p.stdout.read()
                        p.wait()
                        lprint( status )
                        # Now reget the PHP info
                        cmd = "php -i"
                        p = subprocess.Popen( cmd, shell = True, stdin = subprocess.PIPE, stdout = subprocess.PIPE, stderr = subprocess.STDOUT )
                        status = p.stdout.read()
                        p.wait()
                        ptr1 = status.find( "MySQL Support" )
                else:
                    # Tell user how to install
                    lprint( "User has elected to manually install PHP-mySQL." )
                    ac.cprint( "The suggested command for PHP-mySQL is: " + cmd2, ac.YELLOW )
                    ac.cprint( "Please install php-mysql and run this program again.", ac.RED )
                    sys.exit( 1 )
            ptr2 = status[ptr1:].find( "\n" )
            connectorStat = status[ptr1:ptr1 + ptr2]
            lprint( connectorStat, False )
            if connectorStat.find( "enabled" ) > 0:
                ac.cprint( "Php-mysql appears to be present and active." )
            else:
                ac.cprint( "Php-mysql appears to be present but is not enabled.", ac.RED )
                ac.cprint( "Please correct and run this program again.", ac.RED )
            # Version line looks like 'Client API version => mysqlnd 5.0.11-dev'
            ptr2 = status[ptr1:].find( 'mysqlnd' )
            if ptr2 > 0:
                ptr1 = ptr1 + ptr2
                ptr2 = status[ptr1:].find( "-dev" )
                cversion = status[ptr1 + 7:ptr1 + ptr2].strip()
                text = "The installed version of php-mysql is: %s" % cversion
                lprint( text, False )
                cversion = cversion.split( '.' )
                if int( cversion[0] ) == 5:
                    ac.cprint( text, ac.GREEN )
                    ac.cprint( "This version has been tested with the lssdb product.", ac.GREEN )
                else:
                    ac.cprint( text, ac.YELLOW )
                    ac.cprint( "This version has not been tested with the lssdb product.", ac.YELLOW )



def main():
    gv.init()
    print "Checking platform information in stand alone mode."
    try:
        gv.LogFileHandle = open( "lssdb_log.txt", "w" )
    except:
        print "Unable to open log file. Continuing without."

    try:
        GetInfo()
    except KeyboardInterrupt:
        gv.LogFileHandle.close()
        gv.LogFileHandle.close()
        print "Program terminated by user."
        exit()

    gv.LogFileHandle.close()
    print "Program completed normally."

if __name__ == '__main__':
    try:
        main()
    except:
        raise

