#!/usr/bin/python
# This file is used for global settings
# Any variable that needs to be imported into another module should be listed here
# This is also a good place to set variables when testing and debugging.
# First declare the truly global variables here:
sysPlatform = None
distribution = None
WorkingDir = None
dbName = None
dbSetupFile = None
newDBfile = None
setuptarfile = None
lssRoot = None
sampleFile = None
VirtualHostSpecified = None
tarWebFolder = None
LogFileHandle = None
InstalledPath = None
suPassword = None
changePW = None
configFile = None
# This allows two-way binding
# For debugging
# sysPlatform = "Windows"
# sysPlatform = "Linux"
# distribution = "centos"
# distribution = "debian"
# distribution = "fedora"

# Then instantiate an occurrence here so we have only one instance of the variable
def init():
    global sysPlatform
    global distribution
    global WorkingDir
    global dbName
    global dbSetupFile
    global newDBfile
    global setuptarfile
    global lssRoot
    global sampleFile
    global sampleFilePath
    global VirtualHostSpecified
    global tarWebFolder
    global LogFileHandle
    global InstalledPath
    global suPassword
    global changePW
    global configFile
    sysPlatform = ""
    distribution = ""
    WorkingDir = ""
    lssRoot = "/lssdb"
    VirtualHostSpecified = False
    # Then declare one way bound instances for what are effectively constants.
    dbName = "lssdb"  # the name of the database to be added or modified
    dbSetupFile = "DB_SETUP.sql"  # The name of the file inside the tarball that has the DB structure
    InstalledPath = "www"
    newDBfile = "lssdb_default_150715.sql"  # The blank or sample database that will be loaded
    setuptarfile = "LssDatabase_v1_0_150804.tar.gz"  # The distribution tarball
    sampleFile = "lssconfiguration.html"  # Some file that is unique to LSSDB
    sampleFilePath = "/partials/"
    tarWebFolder = "LssDatabase"
    LogFileHandle = object()
    suPassword = ""
    configFile = "/includes/config.php"
    changePW = False

""" To use this file requires a little bit of practice.  
    When using put the import at the top of the file and give it an alias:
        import GlobalVars as gv
    Inside the defined routine treat the alias as a global:
        global gv
    Then use the variables in gv namespace. Like:
        gv.sysPlatform = platform.system()  # Linux or Windows
        gv.distribution = "windows"
        
    If using the variables in a stand alone be sure to call gv.init() to instantiate the variables.
    something like:
    
    def main():
    gv.init()
    print "Checking platform information in stand alone mode."
    try:
        gv.LogFileHandle = open( "lssdb_log.txt", "w" )
    except:
        print "Unable to open log file. Continuing without."

    If using in a file that connects all the subroutines call gv.init() at the first part of
    the collection routine. Like:
    
    def main():
    global gv
    gv.init()
    # Open a log file to save all data collected from segments
    try:
        gv.LogFileHandle = open( "lssdb_log.txt", "w" )
        gv.LogFileHandle.write( "USL LSSDB Setup check. Check Performed: " + datetime.now().strftime( "%Y-%m-%d  %I:%M:%S %p" ) )
    except:
        print "Unable to open log file. Continuing without."

    try:
        GetInfo.GetInfo()
        DBoperations.DBoperations()
        FileOps.FileOps()

"""



