#!/usr/bin/python
'''
Recommends good practice security measures for the lssdb product
Created on Jan 15, 2016

@author: MTA
'''

import os, sys
import subprocess
import MySQLdb
import getpass
import GlobalVars as gv
import AnsiColor as ac

def lprint( text, printtoo = True ):
    if( printtoo ):
        print( text )
    try:
        gv.LogFileHandle.write( text + "\n" )
    except:
        return


def SecurityOps():
    global gv
    secMsg1 = "It is good practice to change the passwords created by installers."
    secMsg2 = "You do not have the default database password for user: lssdb\n"
    secMsg2 += "and this is good practice.\n"
    secMsg3 = "The lssdb database user has the default password created by this installer.\n"
    secMsg3 += "You should change the database lssdb password to your own password to\n"
    secMsg3 += "prevent other users of this installer from knowing your password.\n"
    secMsg4 = "When changing the database lssdb user password you must also edit the config.php\n"
    secMsg4 += "in the %s directory to match the new password." % gv.InstalledPath
    secMsg5 = "This can be performed now using this program."
    secMsg6 = "This program does not install HTTPS services and is unable to check existing certificates."
    secMsg6 += "It would be a good idea to use certificate generated specifically for your domain/n"
    secMsg2 += "if you have used the certificate provided by the Apache installation."
    ac.cprint( secMsg1 )
    if gv.changePW:
        ac.cprint( secMsg2, ac.GREEN )
        ac.cprint( secMsg4, ac.YELLOW )
    else:
        ac.cprint( secMsg3, ac.RED )
        ac.cprint( secMsg4, ac.YELLOW )
        ac.cprint( secMsg5 )
        ac.cprint( "Would you like to change the lssdb database password now?", ac.WHITE, False )
        response = raw_input( "[yN]" )
        if len( response ) > 0:
            if response[0].lower() == "y":
                print
                pw = getpass.getpass( prompt = "Please enter the new password: " )
                pw = pw.strip().replace( "\n", "" )
                try:
                    # Connect using original password
                    db = MySQLdb.connect( "localhost", "lssdb", "lssdb" )
                except:
                    # Some problem encountered connecting.  User must do it manually
                    text = "Unable to connect with the database using the original password.\nPlease perform this task manually."
                    ac.cprint( text, ac.RED )
                    lprint( text, False )
                    sys.exit( 1 )
                # prepare a cursor object using cursor() method
                cursor = db.cursor()
                # Change the lssdb user password
                try:
                    cursor.execute( "USE mysql;" )
                    cursor.execute( "UPDATE user SET password = PASSWORD('%s') WHERE user = 'lssdb';" % pw )
                    cursor.execute( "FLUSH PRIVILEGES;" )
                    text = "User: lssdb password was successfully changed."
                    ac.cprint( text, ac.GREEN )
                    lprint( text, False )
                except:
                    text = "Unable to the change password.\nPlease perform this task manually."
                    ac.cprint( text, ac.RED )
                    lprint( text, False )
                    sys.exit( 1 )

                try:
                    # Modify config.php
                    configfilehandle = open( gv.InstalledPath + gv.configFile, "r" )
                    configFile = configfilehandle.read()
                    configfilehandle.close()
                    ptr1 = configFile.find( "$DB_PASS = '" )
                    ptr2 = configFile[ptr1 + 12:].find( "'" )
                    segment = configFile[ptr1:( ptr1 + ptr2 + 13 )]
                    configFile = configFile.replace( segment, "$DB_PASS = '%s'" % pw )
                    configfilehandle = open( gv.InstalledPath + gv.configFile, "w" )
                    configfilehandle.write( configFile )
                    configfilehandle.close()
                    text = "Configuration file: %s was updated." % ( gv.InstalledPath + gv.configFile )
                    ac.cprint( text, ac.GREEN )
                    lprint( text, False )
                except:
                    text = "Error updating configuration file: %s/n" % ( gv.InstalledPath + gv.configFile )
                    text += "Please update this file manually."
                    ac.cprint( text, ac.RED )
                    lprint( text, False )
        else:
            lprint( "User has elected to change database password manually.", False )




def main():
    gv.init()
    print "Performing Security Operations in stand alone mode."
    try:
        gv.LogFileHandle = open( "lssdb_log.txt", "w" )
    except:
        print "Unable to open log file. Continuing without."
    try:
        gv.InstalledPath = "D:\\xampp\\www\\lssdb"
        SecurityOps()
    except KeyboardInterrupt:
        gv.LogFileHandle.close()
        exit()
    gv.LogFileHandle.close()
    print "Program completed normally."

if __name__ == '__main__':
    try:
        main()
    except:
        raise
